package fr.itsee.zelyx;

import android.os.Parcel;
import android.os.Parcelable;

public class Client implements Parcelable, Comparable<Client> {

    private String id;
    private String nom_entreprise;
    private String siren;
    private String nom;
    private String prenom;
    private String telephone;
    private String telephone2;
    private String adresse;
    private String adresse2;
    private String cp;
    private String ville;
    private String pays;
    private int id_pays;

    public Client() {
    }

    public Client(Client c) {
        this.id = c.getId();
        this.nom_entreprise = c.getNomEntreprise();
        this.nom = c.getNom();
        this.prenom = c.getPrenom();
        this.siren = c.getSiren();
        this.telephone = c.getTelephone();
        this.telephone2 = c.getTelephone2();
        this.adresse = c.getAdresse();
        this.adresse2 = c.getAdresse2();
        this.cp = c.getCp();
        this.ville = c.getVille();
        this.pays = c.getPays();
        this.id_pays = c.getIdPays();
    }


    protected Client(Parcel in) {
        id = in.readString();
        nom_entreprise = in.readString();
        siren = in.readString();
        nom = in.readString();
        prenom = in.readString();
        telephone = in.readString();
        telephone2 = in.readString();
        adresse = in.readString();
        adresse2 = in.readString();
        cp = in.readString();
        ville = in.readString();
        pays = in.readString();
        id_pays = in.readInt();
    }

    public static final Creator<Client> CREATOR = new Creator<Client>() {
        @Override
        public Client createFromParcel(Parcel in) {
            return new Client(in);
        }

        @Override
        public Client[] newArray(int size) {
            return new Client[size];
        }
    };

    @Override
    public int compareTo(Client client) {
        return this.getNomEntreprise().compareTo(client.getNomEntreprise());
    }

    public String getId() {
        return id;
    }
    public String getNomEntreprise() {
        return nom_entreprise;
    }
    public String getSiren() {
        return siren;
    }
    public String getNom() {
        return nom;
    }
    public String getPrenom() {
        return prenom;
    }
    public String getTelephone() {
        return telephone;
    }
    public String getTelephone2() {
        return telephone2;
    }
    public String getAdresse() {
        return adresse;
    }
    public String getAdresse2() {
        return adresse2;
    }
    public String getCp() {
        return cp;
    }
    public String getVille() {
        return ville;
    }
    public String getPays() {
        return pays;
    }
    public int getIdPays() {
        return id_pays;
    }

    public void setId(String id) {
        this.id = id;
    }
    public void setNomEntreprise(String nom_entreprise) {
        this.nom_entreprise = nom_entreprise;
    }
    public void setSiren(String siren) {
        this.siren = siren;
    }
    public void setNom(String nom) {
        this.nom = nom;
    }
    public void setPrenom(String prenom) {
        this.prenom = prenom;
    }
    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }
    public void setTelephone2(String telephone2) {
        this.telephone2 = telephone2;
    }
    public void setAdresse(String adresse) {
        this.adresse = adresse;
    }
    public void setAdresse2(String adresse2) {
        this.adresse2 = adresse2;
    }
    public void setCp(String cp) {
        this.cp = cp;
    }
    public void setVille(String ville) {
        this.ville = ville;
    }
    public void setPays(String pays) {
        this.pays = pays;
    }
    public void setIdPays(int id_pays) {
        this.id_pays = id_pays;
    }

    @Override
    public String toString() {
        return "" + nom_entreprise;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(id);
        parcel.writeString(nom_entreprise);
        parcel.writeString(siren);
        parcel.writeString(nom);
        parcel.writeString(prenom);
        parcel.writeString(telephone);
        parcel.writeString(telephone2);
        parcel.writeString(adresse);
        parcel.writeString(adresse2);
        parcel.writeString(cp);
        parcel.writeString(ville);
        parcel.writeString(pays);
        parcel.writeInt(id_pays);
    }

}
