package fr.itsee.zelyx;

import android.os.Parcel;
import android.os.Parcelable;

import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class Commande implements Parcelable {

    public static final Creator<Commande> CREATOR = new Creator<Commande>() {
        @Override
        public Commande createFromParcel(Parcel in) {
            return new Commande(in);
        }

        @Override
        public Commande[] newArray(int size) {
            return new Commande[size];
        }
    };
    private String num;
    private String nomClient;
    private String idClient;
    private int idPaysClient;
    private String codePostalClient;
    private String date;
    private int qtetotal;
    private double prixTotal;
    private List<Produit> listeProduit;
    private double remiseGlobale = 0.0;
    private String id_operateur = "0";
    private String nomTransporteur = "En retrait";
    private double prixLivraison, prixLivraisonMax1, prixLivraisonMax2, prixLivraisonMax3, prixLivraisonMax4, prixLivraisonMax5, prixLivraisonMax6, prixLivraisonMax7, prixLivraisonMax8, prixLivraisonMax9, prixLivraisonMax10, prixLivraisonMax15, prixLivraisonMax20, prixLivraisonMax25, prixLivraisonMax30, prixLivraisonSup30, prixSupplementLivraison = 0.0;
    private double poidsTotal = 0.0;
    private int idTransporteur, idTransporteurPrixSupplementLivraison;

    DecimalFormat dfPoids = new DecimalFormat("0");

    public Commande() {
        this.listeProduit = new ArrayList<Produit>();
    }

    protected Commande(Parcel in) {
        num = in.readString();
        nomClient = in.readString();
        idClient = in.readString();
        date = in.readString();
        qtetotal = in.readInt();
        prixTotal = in.readDouble();
        listeProduit = in.readArrayList(Produit.class.getClassLoader());
        remiseGlobale = in.readDouble();
        id_operateur = in.readString();
        prixLivraison = in.readDouble();
        poidsTotal = in.readDouble();
        prixLivraisonMax1 = in.readDouble();
        prixLivraisonMax2 = in.readDouble();
        prixLivraisonMax3 = in.readDouble();
        prixLivraisonMax4 = in.readDouble();
        prixLivraisonMax5 = in.readDouble();
        prixLivraisonMax6 = in.readDouble();
        prixLivraisonMax7 = in.readDouble();
        prixLivraisonMax8 = in.readDouble();
        prixLivraisonMax9 = in.readDouble();
        prixLivraisonMax10 = in.readDouble();
        prixLivraisonMax15 = in.readDouble();
        prixLivraisonMax20 = in.readDouble();
        prixLivraisonMax25 = in.readDouble();
        prixLivraisonMax30 = in.readDouble();
        prixLivraisonSup30 = in.readDouble();
        prixSupplementLivraison = in.readDouble();
        idTransporteur = in.readInt();
        idPaysClient = in.readInt();
        codePostalClient = in.readString();
        nomTransporteur = in.readString();
        idTransporteurPrixSupplementLivraison = in.readInt();
    }

    public void addProduit(Produit p) {
        listeProduit.add(0, p);
        incPrixTotal(p.getPrixTotale());
        qtetotal = listeProduit.size();
        incPoidsTotal(p.getPoidsTotale());
    }


    public void delProduit(Produit p) {
        listeProduit.remove(p);
        decPrixTotal(p.getPrixTotale());
        qtetotal = listeProduit.size();
        decPoidsTotal(p.getPoidsTotale());
    }

    public void setId_operateur(String id_operateur) { this.id_operateur = id_operateur; }

    public String getId_operateur() { return id_operateur; };

    public void setRemiseGlobalePourcentage(double n) { this.remiseGlobale = n; }

    public Double getRemiseGlobalePourcentage() { return remiseGlobale; }

    public void incPrixTotal(double n) {
        this.prixTotal += n;
    }

    public void decPrixTotal(double n) {
        this.prixTotal -= n;
    }

    public List<Produit> getListeProduit() {
        return listeProduit;
    }

    public void setListeProduit(List<Produit> listeProduit) {
        this.listeProduit = listeProduit;
    }

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public String getNum() {
        return num;
    }

    public void setNum(String num) {
        this.num = num;
    }

    public int getQtetotal() {
        //Retourne le nombre complet d'article (Nombre de paquets * nombre de produits du paquet anciennement)
        int cpt = 0;
        for (Produit p : listeProduit) {
            cpt += p.getQte();
        }
        return cpt;
    }

    public int getQteTotalNbScanner() {
        int cpt = 0;
        for (Produit p : listeProduit) {
            cpt += p.getNbrScanner();
        }
        return cpt;
    }

    public void setQtetotal(int qtetotal) {
        this.qtetotal = qtetotal;
    }

    public String getNomClient() {
        return nomClient;
    }

    public String getIdClient() { return idClient; }

    public int getIdPaysClient() { return idPaysClient; }

    public String getCodePostalClient() { return codePostalClient; }

    public void setNomClient(String nomClient) {
        this.nomClient = nomClient;
    }

    public void setIdClient(String idClient) { this.idClient = idClient; }

    public void setIdPaysClient(int idPaysClient) { this.idPaysClient = idPaysClient; }

    public void setCodePostalClient(String codePostalClient) { this.codePostalClient = codePostalClient; }

    public double getPrixTotal() {
        double cpt = 0;
        for (Produit p : listeProduit) {
            cpt += p.getPrixTotale();
        }
        prixTotal = cpt;

        //20221205 - Ajout des frais de livraison
        prixTotal = prixTotal + this.getPrixLivraison();
        return prixTotal;
    }

    public double getPoidsTotal() {
        double cpt = 0;
        for (Produit p : listeProduit) {
            cpt += p.getPoidsTotale();
        }
        poidsTotal = cpt;
        return poidsTotal;
    }

    public String getPoidsTotalTxt() {
        //Converti les grammes en kilo grammes
        dfPoids.setMaximumFractionDigits(0);//arrondi à 2 chiffres après la virgule
        dfPoids.setMinimumFractionDigits(0);
        dfPoids.setRoundingMode(RoundingMode.HALF_UP); //ARRONDI AU SUPERIEUR
        if (this.getPoidsTotal() >= 1000) {
            return "" + (dfPoids.format(getPoidsTotal()/1000))+"kg";
        } else {
            return "" + (dfPoids.format(getPoidsTotal()))+"g";
        }
    }

    public double getRemiseTotal() {
        return ((getPrixTotal()*getRemiseGlobalePourcentage())/100);
    }

    public double getPrixTotalAvecRemise() {
        return ((getPrixTotal()-getRemiseTotal()));
    }

    public void setPrixTotal(double prixTotal) {
        this.prixTotal = prixTotal;
    }

    public void setPrixLivraison(double n) { this.prixLivraison = n; }

    public Double getPrixLivraison() { return prixLivraison; }

    public void setPrixLivraisonMax1(double n) { this.prixLivraisonMax1 = n; }

    public Double getPrixLivraisonMax1() { return prixLivraisonMax1; }

    public void setPrixLivraisonMax2(double n) { this.prixLivraisonMax2 = n; }

    public Double getPrixLivraisonMax2() { return prixLivraisonMax2; }

    public void setPrixLivraisonMax3(double n) { this.prixLivraisonMax3 = n; }

    public Double getPrixLivraisonMax3() { return prixLivraisonMax3; }

    public void setPrixLivraisonMax4(double n) { this.prixLivraisonMax4 = n; }

    public Double getPrixLivraisonMax4() { return prixLivraisonMax4; }

    public void setPrixLivraisonMax5(double n) { this.prixLivraisonMax5 = n; }

    public Double getPrixLivraisonMax5() { return prixLivraisonMax5; }

    public void setPrixLivraisonMax6(double n) { this.prixLivraisonMax6 = n; }

    public Double getPrixLivraisonMax6() { return prixLivraisonMax6; }

    public void setPrixLivraisonMax7(double n) { this.prixLivraisonMax7 = n; }

    public Double getPrixLivraisonMax7() { return prixLivraisonMax7; }

    public void setPrixLivraisonMax8(double n) { this.prixLivraisonMax8 = n; }

    public Double getPrixLivraisonMax8() { return prixLivraisonMax8; }

    public void setPrixLivraisonMax9(double n) { this.prixLivraisonMax9 = n; }

    public Double getPrixLivraisonMax9() { return prixLivraisonMax9; }

    public void setPrixLivraisonMax10(double n) { this.prixLivraisonMax10 = n; }

    public Double getPrixLivraisonMax10() { return prixLivraisonMax10; }

    public void setPrixLivraisonMax15(double n) { this.prixLivraisonMax15 = n; }

    public Double getPrixLivraisonMax15() { return prixLivraisonMax15; }

    public void setPrixLivraisonMax20(double n) { this.prixLivraisonMax20 = n; }

    public Double getPrixLivraisonMax20() { return prixLivraisonMax20; }

    public void setPrixLivraisonMax25(double n) { this.prixLivraisonMax25 = n; }

    public Double getPrixLivraisonMax25() { return prixLivraisonMax25; }

    public void setPrixLivraisonMax30(double n) { this.prixLivraisonMax30 = n; }

    public Double getPrixLivraisonMax30() { return prixLivraisonMax30; }

    public void setPrixLivraisonSup30(double n) { this.prixLivraisonSup30 = n; }

    public Double getPrixLivraisonSup30() { return prixLivraisonSup30; }

    public void setPrixSupplementLivraison(double n) { this.prixSupplementLivraison = n; }

    public Double getPrixSupplementLivraison() { return prixSupplementLivraison; }

    public void setIdTransporteurPrixSupplementLivraison(Integer n) { this.idTransporteurPrixSupplementLivraison = n; }

    public int getIdTransporteurPrixSupplementLivraison() { return idTransporteurPrixSupplementLivraison; }

    public void setIdTransporteur(int n) { this.idTransporteur = n; }

    public int getIdTransporteur() { return idTransporteur; }

    public void setNomTransporteur(String nomTransporteur) { this.nomTransporteur = nomTransporteur; }

    public String getNomTransporteur() { return nomTransporteur; }


    public void incPoidsTotal(double n) {
        this.poidsTotal += n;
    }

    public void decPoidsTotal(double n) {
        this.poidsTotal -= n;
    }

    @Override
    public String toString() {
        return "" + num + ": " + listeProduit;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(num);
        parcel.writeString(idClient);
        parcel.writeString(nomClient);
        parcel.writeString(date);
        parcel.writeInt(qtetotal);
        parcel.writeDouble(prixTotal);
        parcel.writeList(listeProduit);
        parcel.writeDouble(remiseGlobale);
        parcel.writeString(id_operateur);
        parcel.writeDouble(prixLivraison);
        parcel.writeDouble(poidsTotal);
        parcel.writeDouble(prixLivraisonMax1);
        parcel.writeDouble(prixLivraisonMax2);
        parcel.writeDouble(prixLivraisonMax3);
        parcel.writeDouble(prixLivraisonMax4);
        parcel.writeDouble(prixLivraisonMax5);
        parcel.writeDouble(prixLivraisonMax6);
        parcel.writeDouble(prixLivraisonMax7);
        parcel.writeDouble(prixLivraisonMax8);
        parcel.writeDouble(prixLivraisonMax9);
        parcel.writeDouble(prixLivraisonMax10);
        parcel.writeDouble(prixLivraisonMax15);
        parcel.writeDouble(prixLivraisonMax20);
        parcel.writeDouble(prixLivraisonMax25);
        parcel.writeDouble(prixLivraisonMax30);
        parcel.writeDouble(prixLivraisonSup30);
        parcel.writeDouble(prixSupplementLivraison);
        parcel.writeInt(idTransporteur);
        parcel.writeInt(idPaysClient);
        parcel.writeString(codePostalClient);
        parcel.writeString(nomTransporteur);
    }
}
