package fr.itsee.zelyx;

import static java.lang.Double.parseDouble;
import static java.lang.Integer.parseInt;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.content.res.AssetFileDescriptor;
import android.graphics.Typeface;
import android.graphics.drawable.Drawable;
import android.media.MediaPlayer;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.DividerItemDecoration;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.SearchView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.epson.epos2.Epos2Exception;
import com.epson.epos2.printer.Printer;
import com.epson.epos2.printer.PrinterStatusInfo;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;
import com.squareup.picasso.Picasso;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.math.RoundingMode;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import java.util.Iterator;

/*ZEBRA*/
import com.symbol.emdk.EMDKManager;
import com.symbol.emdk.EMDKManager.FEATURE_TYPE;
import com.symbol.emdk.EMDKResults;
import com.symbol.emdk.barcode.BarcodeManager;
import com.symbol.emdk.barcode.BarcodeManager.ConnectionState;
import com.symbol.emdk.barcode.BarcodeManager.ScannerConnectionListener;
import com.symbol.emdk.barcode.ScanDataCollection;
import com.symbol.emdk.barcode.Scanner;
import com.symbol.emdk.barcode.Scanner.DataListener;
import com.symbol.emdk.barcode.Scanner.StatusListener;
import com.symbol.emdk.barcode.Scanner.TriggerType;
import com.symbol.emdk.barcode.ScannerConfig;
import com.symbol.emdk.barcode.ScannerException;
import com.symbol.emdk.barcode.ScannerInfo;
import com.symbol.emdk.barcode.ScannerResults;
import com.symbol.emdk.barcode.StatusData;
import com.symbol.emdk.barcode.StatusData.ScannerStates;

/* IMPRIMANTE */
import com.epson.epos2.printer.ReceiveListener;

import android.widget.AdapterView;
import android.widget.ArrayAdapter;

/* ZEBRA */
/*public class CommandesActivity extends AppCompatActivity {*/
public class CommandesActivity extends AppCompatActivity implements EMDKManager.EMDKListener, DataListener, StatusListener, ScannerConnectionListener, CompoundButton.OnCheckedChangeListener, ReceiveListener {

    //public Integer cptFlashProduit = 0;
    public static ProduitAdapter mAdapter;
    public static ClientAdapter mAdapterClient;
    public static TransporteurAdapter mAdapterTransporteur;
    public static TextView prixTotal, poidsTotal, qteTotal, remiseGlobaleTotal, textRemiseGlobale;
    public static LinearLayout remiseGlobaleLigne;
    public static List<Produit> listeAllProduits;
    public static List<Client> listeAllClients;
    public static List<Client> listeAllClientsFiltre;
    public static List<Transporteur> listeAllTransporteurs;
    public static List<Transporteur> listeAllTransporteursFiltre;
    public static List<TransporteurChronopostFranceSupplement> listeAllSupplementTransporteurChronopostFrance;
    public static Commande currentCommande;
    public static String dernierTypeTicket;
    public static Commande currentCommandeFiltre;
    public static Commande commandeAImprimer = new Commande();
    static Boolean filtreRechercheEnCours = false, synchronisationEnCours = true; //Synchro au lancement
    private static TextView num;
    private final Object lock = new Object();
    public List<Produit> listeRupture;
    List<Commande> listeCommande = new ArrayList<>(3);
    public static Button syncButton;
    public LinearLayout synchronisation_en_cours;
    public Boolean synchronisation_manuelle = true;
    public static RecyclerView recyclerView;
    public static RecyclerView recyclerViewClients, recyclerViewTransporteurs;
    public static LinearLayout barNom;
    public static LinearLayout barIntituleChamps;
    public static LinearLayout barIntituleChampsClients, barIntituleChampsTransporteurs;
    public static LinearLayout infos;
    public static LinearLayout livraisonLigne;
    public static RelativeLayout imprimer, choixCommande;
    private TextView date, actifTab, previousTab, c1, reimp, imprimerCommande;
    public static TextView modeNom;
    public static TextView prixLivraison;
    public static SearchView searchBar;
    public static SearchView searchBarProduitCommande;
    public static SearchView searchBarClientCommande;
    public static SearchView searchBarTransporteurCommande;
    public static TextView nom;
    private int selectedTab = 1;
    private Commande newCommande;
    private Commande commandeVide = new Commande();
    private Boolean scanEnPermanence = false;
    /* ZEBRA */
    //Partie Scanner
    private EMDKManager emdkManager = null;
    private BarcodeManager barcodeManager = null;
    private Scanner scanner = null;
    private TextView textViewStatus = null;
    private Spinner spinnerScannerDevices = null;
    private List<ScannerInfo> deviceList = null;
    private int defaultIndex = 0; // Keep the default scanner
    private int scannerIndex = 0; // Keep the selected scanner
    private int dataLength = 0;
    private String statusString = "";
    //SCANNER EN PERMANENCE (bSoftTriggerSelected = TRUE)
    private boolean bSoftTriggerSelected = false;
    //20221222 - Par défaut change la configuration du scanner
    private boolean bDecoderSettingsChanged = true;
    private boolean bExtScannerDisconnected = false;

    private LinearLayout poidsTotalL;

    private String NumeroDerniereCommandeAnnulee = "0";

    private ImageView image_produit_full;
    private TextView initialesVendeur, codeBoutique;
    public static ImageView activerToujoursScanner, reloadScanner;
    public static Button changerClient, changerTransporteur;
    private List<Commande> resultatRecherche;
    private List<Client> resultatRechercheClients;
    private List<Transporteur> resultatRechercheTransporteurs;
    public static ImageView ajouterRemiseCommande;
    public TextView messageFixe;
    private Button fermerCommandesActivity, nouvelleCommande;
    private Integer afficheLogsScanner = 0;
    public static int affichelisteclients, affichelistetransporteurs = 0;

    ///////////IMPRESSION
    public String ligneProduitsRassemblee = "";
    public Double ligneProduitsRassembleeTotal = 0.0;
    public Integer ligneProduitsRassembleeTotalQte = 0;
    private static final int REQUEST_PERMISSION = 100;
    private Printer mPrinter = null;
    private int nbTentativesImpression = 0;
    private TextView logsImpression;

    //Son
    private MediaPlayer mediaPlayer;

    public static Produit getProduitInCommande(String code128) {
        for (Produit pr : currentCommande.getListeProduit()) {
            if (pr.getCode128().equals(code128)) {
                return pr;
            }
        }
        return null;
    }

    @Override
    public void onBackPressed() {
        //Fermer cette fenêtre
        new AlertDialog.Builder(CommandesActivity.this)
                .setIcon(android.R.drawable.ic_dialog_alert)
                .setTitle("Confirmation")
                .setMessage("Etes-vous sûr de vouloir fermer les commandes?")
                .setPositiveButton("Oui", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        scanEnPermanence = false;
                        bSoftTriggerSelected = false;
                        if (scanner != null) {
                            scanner.triggerType = TriggerType.HARD;
                        }
                        //Fermer le clavier
                        hideKeyboard(CommandesActivity.this);

                        // The application is in background
                        // Release the barcode manager resources
                        deInitScanner();
                        deInitBarcodeManager();
                        Intent returnIntent = new Intent();
                        setResult(Activity.RESULT_OK, returnIntent);
                        finish();
                    }
                })
                .setNegativeButton("Non", null)
                .show();
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_commandes);

        logsImpression = findViewById(R.id.messageFixe);

        reloadScanner = findViewById(R.id.reloadScanner);
        activerToujoursScanner = findViewById(R.id.activerToujoursScanner);

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

        poidsTotalL = findViewById(R.id.poidsTotalL);
        prixLivraison = findViewById(R.id.prixLivraison);
        nouvelleCommande = findViewById(R.id.nouvelleCommande);
        fermerCommandesActivity = findViewById(R.id.fermerCommandesActivity);
        textViewStatus = findViewById(R.id.textViewStatus);
        spinnerScannerDevices = findViewById(R.id.spinnerScannerDevices);
        date = findViewById(R.id.date);
        num = findViewById(R.id.num);
        nom = findViewById(R.id.nom);
        changerClient = findViewById(R.id.nomEdit);
        changerTransporteur = findViewById(R.id.changerTransporteur);
        remiseGlobaleLigne = findViewById(R.id.remiseGlobaleLigne);
        textRemiseGlobale = findViewById(R.id.textRemiseGlobale);
        remiseGlobaleTotal = findViewById(R.id.remiseGobaleTotal);
        prixTotal = findViewById(R.id.prixTotal);
        poidsTotal = findViewById(R.id.poidsTotal);

        searchBar = findViewById(R.id.bar_de_recherche);
        searchBarProduitCommande = findViewById(R.id.bar_de_recherche_commande);
        searchBarClientCommande = findViewById(R.id.bar_de_recherche_clients);
        searchBarTransporteurCommande = findViewById(R.id.bar_de_recherche_transporteurs);

        searchBar.clearFocus();
        searchBarProduitCommande.clearFocus();
        searchBarClientCommande.clearFocus();
        searchBarTransporteurCommande.clearFocus();

        qteTotal = findViewById(R.id.qteTotal);
        c1 = findViewById(R.id.c1);
        reimp = findViewById(R.id.reimp);
        imprimerCommande = findViewById(R.id.imprimerCommande);
        ajouterRemiseCommande = findViewById(R.id.remiseGlobale);
        modeNom = findViewById(R.id.modeNom);
        livraisonLigne = findViewById(R.id.livraisonLigne);
        messageFixe = findViewById(R.id.messageFixe);
        barNom = findViewById(R.id.barNom);
        barIntituleChamps = findViewById(R.id.barIntituleChamps);
        barIntituleChampsClients = findViewById(R.id.barIntituleChampsClients);
        barIntituleChampsTransporteurs = findViewById(R.id.barIntituleChampsTransporteurs);
        infos = findViewById(R.id.infos);
        imprimer = findViewById(R.id.imprimer);
        choixCommande = findViewById(R.id.choixCommande);
        recyclerView = findViewById(R.id.recycler_view);
        recyclerViewClients = findViewById(R.id.recycler_view_clients);
        recyclerViewTransporteurs = findViewById(R.id.recycler_view_transporteurs);

        /* ZEBRA */
        deviceList = new ArrayList<ScannerInfo>();
        EMDKResults results = EMDKManager.getEMDKManager(getApplicationContext(), this);
        if (results.statusCode != EMDKResults.STATUS_CODE.SUCCESS) {
            updateStatus("EMDKManager object non initialisé!");
            //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
                messageFixe.setText("Impossible d'initialiser le scanner!" + "\n" + "Veuillez redémarrer l'application!");
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setVisibility(View.VISIBLE);
            return;
        }
        addSpinnerScannerDevicesListener();
        //Initialisation du scanner ZEBRA
        bSoftTriggerSelected = false;
        bExtScannerDisconnected = false;
        deInitScanner();
        initScanner();
        setDecoders();
        // Set default scanner IMPORTANT PERMET D'INITIALISER LE SCANNER
        spinnerScannerDevices.setSelection(defaultIndex);

        searchBar.clearFocus();
        searchBarProduitCommande.clearFocus();
        searchBarClientCommande.clearFocus();
        searchBarTransporteurCommande.clearFocus();
        //searchBar.setEnabled(false);

        actifTab = c1;
        previousTab = null;
        actifTab.setTextColor(getResources().getColor(R.color.colorBlanc));
        actifTab.setBackgroundResource(R.drawable.button_style_selected);
        actifTab.setTypeface(null, Typeface.BOLD);
        mAdapter = new ProduitAdapter(new Commande(), getApplicationContext());
        mAdapterClient = new ClientAdapter(getApplicationContext());
        mAdapterTransporteur = new TransporteurAdapter(getApplicationContext());
        listeCommande.add(null);
        listeCommande.add(null);
        listeCommande.add(null);
        getListeCommandes();

        currentCommande = listeCommande.get(selectedTab - 1);
        currentCommandeFiltre = listeCommande.get(selectedTab - 1);
        RecyclerView.LayoutManager mLayoutManager = new LinearLayoutManager(getApplicationContext());
        RecyclerView.LayoutManager mLayoutManagerClients = new LinearLayoutManager(getApplicationContext());
        RecyclerView.LayoutManager mLayoutManagerTranspoteurs = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(mLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.addItemDecoration(new DividerItemDecoration(this, LinearLayoutManager.VERTICAL));
        recyclerView.setAdapter(mAdapter);
        recyclerViewClients.setLayoutManager(mLayoutManagerClients);
        recyclerViewClients.setItemAnimator(new DefaultItemAnimator());
        recyclerViewClients.addItemDecoration(new DividerItemDecoration(this, LinearLayoutManager.VERTICAL));
        recyclerViewClients.setAdapter(mAdapterClient);
        recyclerViewTransporteurs.setLayoutManager(mLayoutManagerTranspoteurs);
        recyclerViewTransporteurs.setItemAnimator(new DefaultItemAnimator());
        recyclerViewTransporteurs.addItemDecoration(new DividerItemDecoration(this, LinearLayoutManager.VERTICAL));
        recyclerViewTransporteurs.setAdapter(mAdapterTransporteur);

        initialesVendeur = findViewById(R.id.initialesVendeur);
        initialesVendeur.setText(MainActivity.initiales_vendeur);
        initialesVendeur.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    afficherLogsScanner();
                }
            }
        });

        codeBoutique = findViewById(R.id.codeBoutique);
        codeBoutique.setText(MainActivity.code_boutique);

        image_produit_full = findViewById(R.id.image_produit_full);

        //Permet de fermer l'image en plein écran
        image_produit_full.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    image_produit_full.setEnabled(false);
                }
            }
        });

        /*RE-IMPRIMER TICKET*/
        reimp.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    if (MainActivity.mac_imprimante == null || MainActivity.mac_imprimante == "") {
                        afficherToast("KO", "Aucune @MAC fourni pour l'imprimante!");
                    } else if (listeAllProduits != null) {
                        DialogCommandesActivityListCommandesJour.show(CommandesActivity.this, 0);
                    } else {
                        afficherToast("KO", "Aucun articles chargés!");
                    }
                }
            }
        });

        /*IMPRIMER TICKET CURRENTCOMMANDE*/
        imprimerCommande.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    if (currentCommande != null) {
                        if (MainActivity.mac_imprimante != null && MainActivity.mac_imprimante != "") {
                            if (!currentCommande.getNomClient().equals("")) {
                                if (currentCommande.getListeProduit().size() > 0) {
                                    if (isOnline()) {
                                        saveListeCommandes();
                                        //Contrôler le stock uniquement lors de la finalisation de la commande
                                        try {
                                            //Au lieu de rafraichir les stocks on récupère une nouvelle fois tous les produits
                                            synchronisation_manuelle = false;
                                            new GetAllProduitsAsyncTask().execute();
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }

                                        //On affiche la fenetre de dialogue du choix du ticket
                                        new AlertDialog.Builder(CommandesActivity.this)
                                                .setIcon(android.R.drawable.ic_dialog_alert)
                                                .setTitle("Confirmation")
                                                .setMessage("Quel type de ticket souhaitez-vous imprimer ?")
                                                .setPositiveButton("Détaillé", new DialogInterface.OnClickListener() {
                                                    @Override
                                                    public void onClick(DialogInterface dialog, int which) {
                                                        //controle des stocks
                                                        try {
                                                            //On lancer l'impression après VerifStockAsync
                                                            dernierTypeTicket = "détaillé";
                                                            new VerifStockAsyncTask().execute();
                                                        } catch (Exception e) {
                                                            e.printStackTrace();
                                                        }
                                                    }

                                                })
                                                .setNegativeButton("Rassemblé", new DialogInterface.OnClickListener() {
                                                    @Override
                                                    public void onClick(DialogInterface dialog, int which) {
                                                        try {
                                                            //On lancer l'impression après VerifStockAsync
                                                            dernierTypeTicket = "rassemblé";
                                                            new VerifStockAsyncTask().execute();
                                                        } catch (Exception e) {
                                                            e.printStackTrace();
                                                        }
                                                    }
                                                })
                                                .show();
                                    } else {
                                        Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
                                        CommandesActivity.this.startActivity(intent);
                                        CommandesActivity.this.overridePendingTransition(0, 0);
                                    }
                                } else {
                                    afficherToast("KO", "Aucun articles dans la commande!");
                                }
                            } else {
                                afficherToast("KO", "Vous devez choisir un client!");
                            }
                        } else {
                            afficherToast("KO", "Aucune @MAC fourni pour l'imprimante!");
                        }
                    } else {
                        afficherToast("KO", "Vous devez créer une nouvelle commande!");
                    }
                }
            }
        });
        /*CHANGER NOM CLIENT*/
        changerClient.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    if (currentCommande != null && (listeAllClientsFiltre == null || listeAllClientsFiltre.size() == 0)) {
                        afficherToast("KO", "Aucun client disponible!");
                    } else if (currentCommande != null && affichelisteclients == 0) {
                        //Charger les transporteurs uniquement si pas présent sur la commande en cours
                        affichelisteclients = 1;
                        infos.setVisibility(View.GONE);
                        imprimer.setVisibility(View.GONE);
                        choixCommande.setVisibility(View.GONE);
                        barNom.setVisibility(View.GONE);
                        barIntituleChamps.setVisibility(View.GONE);
                        recyclerView.setVisibility(View.GONE);
                        recyclerViewTransporteurs.setVisibility(View.GONE);
                        activerToujoursScanner.setVisibility(View.GONE);
                        reloadScanner.setVisibility(View.GONE);
                        ajouterRemiseCommande.setVisibility(View.GONE);
                        searchBar.setVisibility(View.GONE);
                        searchBarProduitCommande.setVisibility(View.GONE);
                        searchBarTransporteurCommande.setVisibility(View.GONE);
                        searchBarClientCommande.setVisibility(View.VISIBLE);

                        searchBar.clearFocus();
                        searchBarProduitCommande.clearFocus();
                        searchBarClientCommande.clearFocus();

                        barIntituleChampsTransporteurs.setVisibility(View.GONE);
                        recyclerViewTransporteurs.setVisibility(View.GONE);
                        barIntituleChampsClients.setVisibility(View.VISIBLE);
                        recyclerViewClients.setVisibility(View.VISIBLE);
                    } else if (currentCommande != null) {
                        affichelisteclients = 0;
                        searchBarTransporteurCommande.setVisibility(View.GONE);
                        searchBarClientCommande.setVisibility(View.GONE);
                        searchBar.setVisibility(View.VISIBLE);
                        searchBarProduitCommande.setVisibility(View.VISIBLE);

                        searchBar.clearFocus();
                        searchBarProduitCommande.clearFocus();
                        searchBarClientCommande.clearFocus();

                        barIntituleChampsClients.setVisibility(View.GONE);
                        recyclerViewClients.setVisibility(View.GONE);
                        recyclerViewTransporteurs.setVisibility(View.GONE);
                        infos.setVisibility(View.VISIBLE);
                        imprimer.setVisibility(View.VISIBLE);
                        choixCommande.setVisibility(View.VISIBLE);
                        barNom.setVisibility(View.VISIBLE);
                        barIntituleChamps.setVisibility(View.VISIBLE);
                        activerToujoursScanner.setVisibility(View.VISIBLE);
                        reloadScanner.setVisibility(View.VISIBLE);
                        ajouterRemiseCommande.setVisibility(View.VISIBLE);
                        recyclerView.setVisibility(View.VISIBLE);
                    }
                }
            }
        });

        /*CHANGER TRANSPORTEUR*/
        changerTransporteur.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    if (currentCommande == null) {
                        afficherToast("KO", "Veuillez créer une commande avant de choisir un transporteur!");
                    } else if (currentCommande != null && affichelistetransporteurs == 0 && listeAllTransporteursFiltre != null && listeAllTransporteursFiltre.size() > 0) {
                        //Charger les transporteurs uniquement si pas présent sur la commande en cours
                        affichelistetransporteurs = 1;
                        infos.setVisibility(View.GONE);
                        imprimer.setVisibility(View.GONE);
                        choixCommande.setVisibility(View.GONE);
                        barNom.setVisibility(View.GONE);
                        barIntituleChamps.setVisibility(View.GONE);
                        recyclerView.setVisibility(View.GONE);
                        recyclerViewTransporteurs.setVisibility(View.GONE);
                        activerToujoursScanner.setVisibility(View.GONE);
                        reloadScanner.setVisibility(View.GONE);
                        ajouterRemiseCommande.setVisibility(View.GONE);
                        searchBar.setVisibility(View.GONE);
                        searchBarProduitCommande.setVisibility(View.GONE);
                        searchBarClientCommande.setVisibility(View.GONE);
                        barIntituleChampsClients.setVisibility(View.GONE);
                        recyclerViewClients.setVisibility(View.GONE);
                        searchBarTransporteurCommande.setVisibility(View.VISIBLE);

                        searchBar.clearFocus();
                        searchBarProduitCommande.clearFocus();
                        searchBarClientCommande.clearFocus();


                        barIntituleChampsTransporteurs.setVisibility(View.VISIBLE);
                        recyclerViewTransporteurs.setVisibility(View.VISIBLE);
                    } else {
                        afficherToast("KO", "Les transporteurs sont indisponibles. Veuillez lancer une synchronisation.");
                    }
                }
            }
        });
        ajouterRemiseCommande.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    if (currentCommande != null) {
                        DialogRemiseGlobaleActivityEditRemise.show(CommandesActivity.this, 0);
                        //Fermer le clavier
                        hideKeyboard(CommandesActivity.this);
                    } else {
                        afficherToast("KO", "Vous devez créer une nouvelle commande!");
                    }
                }
            }
        });

        activerToujoursScanner.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    if (scanEnPermanence) {
                        scanEnPermanence = false;
                        activerToujoursScanner.setBackgroundResource(R.drawable.barcode_scanner_manuel);
                    } else {
                        scanEnPermanence = true;
                        activerToujoursScanner.setBackgroundResource(R.drawable.barcode_scanner);
                    }
                    try {
                        if (scanner.isReadPending()) {
                            scanner.cancelRead();
                        }

                        if (!scanEnPermanence)
                            scanner.triggerType = TriggerType.SOFT_ONCE;
                        else
                            scanner.triggerType = TriggerType.SOFT_ALWAYS;

                        scanner.read();
                        //Fermer le clavier
                        hideKeyboard(CommandesActivity.this);
                    } catch (ScannerException e) {
                        e.printStackTrace();
                    }
                }
            }
        });

        reloadScanner.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    messageFixe.setVisibility(View.GONE);
                    messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
                    messageFixe.setText("");
                    activerToujoursScanner.setBackgroundResource(R.drawable.barcode_scanner_manuel);

                    // The application is in foreground
                    if (emdkManager != null) {
                        // Acquire the barcode manager resources
                        initBarcodeManager();
                        // Enumerate scanner devices
                        enumerateScannerDevices();
                        // Set selected scanner
                        spinnerScannerDevices.setSelection(scannerIndex);
                        // Initialize scanner
                        initScanner();

                        scanEnPermanence = false;
                        scanner.triggerType = TriggerType.SOFT_ONCE;

                        try {
                            scanner.read();
                        } catch (Exception e) {

                        }
                    }
                    //Fermer le clavier
                    hideKeyboard(CommandesActivity.this);
                }
            }
        });

        searchBarProduitCommande.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {
                if (currentCommande != null && currentCommande.getListeProduit().size()>0) {
                    searchBarProduitCommande.clearFocus();
                    if (!s.isEmpty()) {
                        filtreRechercheEnCours = true;
                        faireRecherche(s);
                    } else {
                        filtreRechercheEnCours = false;
                        mAdapter.setCmd(currentCommande);
                    }
                    if (s.isEmpty()) {
                        filtreRechercheEnCours = false;
                        mAdapter.setCmd(currentCommande);
                    }
                    mAdapter.notifyDataSetChanged();
                }
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                if (s.isEmpty()) {
                    mAdapter.setCmd(currentCommande);
                    mAdapter.notifyDataSetChanged();
                }
                return false;
            }
        });
        searchBarProduitCommande.clearFocus();
        filtreRechercheEnCours = false;

        searchBarClientCommande.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {
                if (currentCommande != null && listeAllClients.size()>0) {
                    searchBarClientCommande.clearFocus();
                    if (!s.isEmpty()) {
                        filtreRechercheEnCours = true;
                        faireRechercheClients(s);
                    } else {
                        filtreRechercheEnCours = false;
                    }
                    if (s.isEmpty()) {
                        filtreRechercheEnCours = false;
                    }
                    mAdapterClient.notifyDataSetChanged();
                }
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                if (s.isEmpty()) {
                    listeAllClientsFiltre = listeAllClients;
                    mAdapterClient.notifyDataSetChanged();
                }
                return false;
            }
        });
        searchBarClientCommande.clearFocus();

        searchBarTransporteurCommande.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {
                if (currentCommande != null && listeAllTransporteurs.size()>0) {
                    searchBarTransporteurCommande.clearFocus();
                    if (!s.isEmpty()) {
                        filtreRechercheEnCours = true;
                        faireRechercheTransporteurs(s);
                    } else {
                        filtreRechercheEnCours = false;
                    }
                    if (s.isEmpty()) {
                        filtreRechercheEnCours = false;
                    }
                    mAdapterTransporteur.notifyDataSetChanged();
                }
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                if (s.isEmpty()) {
                    listeAllTransporteursFiltre = listeAllTransporteurs;
                    mAdapterTransporteur.notifyDataSetChanged();
                }
                return false;
            }
        });
        searchBarTransporteurCommande.clearFocus();

        mAdapter.setOnItemClickListener(new ProduitAdapter.OnItemClickListener() {
            protected boolean isOnline() {
                ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
                NetworkInfo netInfo = cm.getActiveNetworkInfo();
                return netInfo != null && netInfo.isConnectedOrConnecting();
            }

            @Override
            public void onRefClick(int position) {
                if (filtreRechercheEnCours == false) {
                    Intent intent = new Intent(CommandesActivity.this, FicheProduitActivity.class);
                    intent.putExtra("produit", getProduit(position));
                    CommandesActivity.this.startActivityForResult(intent, 3);
                    CommandesActivity.this.overridePendingTransition(0, 0);
                } else {
                    afficherToast("ENCOURS", "Recherche en cours...");
                }
            }

            @Override
            public void onPhotoClick(int position, Drawable imageDrawable, String lien_image) {
                if (filtreRechercheEnCours == false) {
                    Picasso.with(getApplicationContext()).load(MainActivity.backOfficeURLIMG + lien_image.replace(".jpg", "_full.jpg")).placeholder(R.drawable.image_not_found).error(R.drawable.image_not_found).into(image_produit_full);
                    image_produit_full.setVisibility(View.VISIBLE);
                    image_produit_full.setEnabled(true);
                    image_produit_full.setAdjustViewBounds(true);
                } else {
                    afficherToast("ENCOURS", "Recherche en cours...");
                }
            }

            @Override
            public void onSupprClick(final int position) {
                if (filtreRechercheEnCours == false) {
                    new AlertDialog.Builder(CommandesActivity.this)
                            .setIcon(android.R.drawable.ic_dialog_alert)
                            .setTitle("Confirmation")
                            .setMessage("Etes-vous sûr de vouloir supprimer cet article?")
                            .setPositiveButton("Oui", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    currentCommande.delProduit(getProduit(position));
                                    mAdapter.notifyDataSetChanged();
                                    mAdapterTransporteur.notifyDataSetChanged();
                                    afficheCommande();
                                }

                            })
                            .setNegativeButton("Non", null)
                            .show();
                } else {
                    afficherToast("ENCOURS", "Recherche en cours...");
                }
            }

            @Override
            public void onPlusClick(int position) {
                if (filtreRechercheEnCours == false) {
                    Produit p = getProduit(position);
                    int reste = p.getStock() - p.getQte() - 1;

                    if (reste == 0) {
                        afficherToast("NEXISTEPAS", "Stock null "+currentCommande.getListeProduit().get(position).getRef()+" "+currentCommande.getListeProduit().get(position).getColoris()+" !");
                        p.incQte();
                    } else {
                        p.incQte();
                    }

                    afficheCommande();
                } else {
                    afficherToast("ENCOURS", "Recherche en cours...");
                }
            }

            @Override
            public void onMoinsClick(int position) {
                if (filtreRechercheEnCours == false) {
                    Produit p = getProduit(position);
                    currentCommande.getListeProduit().get(position).decQte();
                    afficheCommande();
                } else {
                    afficherToast("ENCOURS", "Recherche en cours...");
                }
            }

            @Override
            public void onQuantiteClick(int position) {
                if (filtreRechercheEnCours == false) {
                    DialogCommandesActivityEditQte.show(CommandesActivity.this, position);
                } else {
                    afficherToast("ENCOURS", "Recherche en cours...");
                }
            }

            @Override
            public void onPrixClick(int position) {
                if (filtreRechercheEnCours == false) {
                    DialogCommandesActivityEditPrix.show(CommandesActivity.this, position);
                } else {
                    afficherToast("ENCOURS", "Recherche en cours...");
                }
            }

        });

        mAdapterClient.setOnItemClickListener(new ClientAdapter.OnItemClickListener() {

            @Override
            public void onChoisirClick(int position) {
                //Afficher/Masquer les éléments
                CommandesActivity.affichelisteclients = 0;
                CommandesActivity.barNom.setVisibility(View.VISIBLE);
                CommandesActivity.barIntituleChamps.setVisibility(View.VISIBLE);
                CommandesActivity.barIntituleChampsClients.setVisibility(View.GONE);
                CommandesActivity.recyclerViewClients.setVisibility(View.GONE);
                CommandesActivity.recyclerView.setVisibility(View.VISIBLE);
                CommandesActivity.searchBar.setVisibility(View.VISIBLE);
                CommandesActivity.searchBarProduitCommande.setVisibility(View.VISIBLE);
                CommandesActivity.searchBarClientCommande.setVisibility(View.GONE);
                CommandesActivity.infos.setVisibility(View.VISIBLE);
                CommandesActivity.imprimer.setVisibility(View.VISIBLE);
                CommandesActivity.choixCommande.setVisibility(View.VISIBLE);
                CommandesActivity.activerToujoursScanner.setVisibility(View.VISIBLE);
                CommandesActivity.reloadScanner.setVisibility(View.VISIBLE);
                CommandesActivity.ajouterRemiseCommande.setVisibility(View.VISIBLE);
            }

        });

        mAdapterTransporteur.setOnItemClickListener(new TransporteurAdapter.OnItemClickListener() {
            @Override
            public void onChoisirClick(int position) {
                /*currentCommande.setNomTransporteur(getTransporteur(position).getNomTransporteur());
                currentCommande.setIdTransporteur(getTransporteur(position).getId());
                currentCommande.setPrixLivraison(getTransporteur(position).getPrixTransporteur());
                currentCommande.setPrixLivraisonMax1(getTransporteur(position).getMax1());
                currentCommande.setPrixLivraisonMax2(getTransporteur(position).getMax2());
                currentCommande.setPrixLivraisonMax3(getTransporteur(position).getMax3());
                currentCommande.setPrixLivraisonMax4(getTransporteur(position).getMax4());
                currentCommande.setPrixLivraisonMax5(getTransporteur(position).getMax5());
                currentCommande.setPrixLivraisonMax6(getTransporteur(position).getMax6());
                currentCommande.setPrixLivraisonMax7(getTransporteur(position).getMax7());
                currentCommande.setPrixLivraisonMax8(getTransporteur(position).getMax8());
                currentCommande.setPrixLivraisonMax9(getTransporteur(position).getMax9());
                currentCommande.setPrixLivraisonMax10(getTransporteur(position).getMax10());
                currentCommande.setPrixLivraisonMax15(getTransporteur(position).getMax15());
                currentCommande.setPrixLivraisonMax20(getTransporteur(position).getMax20());
                currentCommande.setPrixLivraisonMax25(getTransporteur(position).getMax25());
                currentCommande.setPrixLivraisonMax30(getTransporteur(position).getMax30());
                currentCommande.setPrixLivraisonSup30(getTransporteur(position).getSup30());

                if (listeAllSupplementTransporteurChronopostFrance != null && currentCommande.getIdPaysClient() == 8 && currentCommande.getCodePostalClient() != null && currentCommande.getIdTransporteur() == 8) {
                    //Chercher le supplément
                    TransporteurChronopostFranceSupplement ts = getSupplementTransporteurChronospostFrance(currentCommande.getCodePostalClient());
                    if (ts != null && currentCommande != null) {
                        currentCommande.setIdTransporteurPrixSupplementLivraison(8);
                        currentCommande.setPrixSupplementLivraison(ts.getSupplementTransporteur());
                    } else {
                        currentCommande.setIdTransporteurPrixSupplementLivraison(0);
                        currentCommande.setPrixSupplementLivraison(0);
                    }
                }
                appliquerPrixLivraison();

                recyclerViewClients.setVisibility(View.GONE);
                recyclerViewTransporteurs.setVisibility(View.GONE);
                recyclerView.setVisibility(View.VISIBLE);

                try {
                    new UpdateCommandeJSONAsyncTask().execute();
                } catch (Exception e) {
                    e.printStackTrace();
                }*/
                //Afficher/masquer les éléments
                CommandesActivity.affichelistetransporteurs = 0;
                CommandesActivity.barIntituleChampsTransporteurs.setVisibility(View.GONE);
                CommandesActivity.recyclerViewTransporteurs.setVisibility(View.GONE);
                CommandesActivity.barIntituleChampsClients.setVisibility(View.GONE);
                CommandesActivity.recyclerViewClients.setVisibility(View.GONE);
                CommandesActivity.searchBarTransporteurCommande.setVisibility(View.GONE);
                CommandesActivity.searchBarClientCommande.setVisibility(View.GONE);
                CommandesActivity.barNom.setVisibility(View.VISIBLE);
                CommandesActivity.barIntituleChamps.setVisibility(View.VISIBLE);
                CommandesActivity.recyclerView.setVisibility(View.VISIBLE);
                CommandesActivity.searchBar.setVisibility(View.VISIBLE);
                CommandesActivity.searchBarProduitCommande.setVisibility(View.VISIBLE);
                CommandesActivity.infos.setVisibility(View.VISIBLE);
                CommandesActivity.imprimer.setVisibility(View.VISIBLE);
                CommandesActivity.choixCommande.setVisibility(View.VISIBLE);
                CommandesActivity.activerToujoursScanner.setVisibility(View.VISIBLE);
                CommandesActivity.reloadScanner.setVisibility(View.VISIBLE);
                CommandesActivity.ajouterRemiseCommande.setVisibility(View.VISIBLE);
                if (CommandesActivity.currentCommande.getPrixLivraison() > 0) {
                    CommandesActivity.livraisonLigne.setVisibility(View.VISIBLE);
                } else {
                    CommandesActivity.livraisonLigne.setVisibility(View.GONE);
                }
            }
        });

        searchBar.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {
                if (currentCommande != null && listeAllProduits != null && s != null) {
                    searchBarProduitCommande.clearFocus();
                    searchBarTransporteurCommande.clearFocus();
                    searchBarClientCommande.clearFocus();
                    if (s.length() > 0) {
                        Intent intent = new Intent(CommandesActivity.this, RechercheActivity.class);
                        intent.putExtra("recherche", s);
                        CommandesActivity.this.startActivityForResult(intent, 4);
                        CommandesActivity.this.overridePendingTransition(0, 0);
                    }
                }
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                return false;
            }
        });
        currentCommande = listeCommande.get(selectedTab - 1);
        if (currentCommande != null) {
            mAdapter.setCmd(currentCommande);
            recyclerView.setAdapter(mAdapter);
            recyclerViewTransporteurs.setAdapter(mAdapterTransporteur);
            afficheCommande();
        }
        /* NON ZEBRA */
        syncButton = findViewById(R.id.sync);
        synchronisation_en_cours = findViewById(R.id.synchronisation_en_cours);
        syncButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    /*SYNCHRONISATION DE LA LISTE DES PRODUITS ET CLIENTS*/
                    listeAllProduits = null;
                    try {
                        /*SYNCHRONISATION DES PRODUITS, DES CLIENTS ET DES TRANSPORTEURS*/
                        synchronisation_manuelle = true;
                        new GetAllProduitsAsyncTask().execute();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                }
            }
        });

        searchBarProduitCommande.clearFocus();
        filtreRechercheEnCours = false;

        try {
            synchronisation_manuelle = true;
            new GetAllProduitsAsyncTask().execute();
        } catch (Exception e) {
            e.printStackTrace();
        }

        afficheCommande();
    }

    public static void appliquerPrixLivraison() {
        DecimalFormat df = new DecimalFormat("0.00");
        df.setMaximumFractionDigits(2);//arrondi à 2 chiffres après la virgule
        df.setMinimumFractionDigits(2);
        df.setDecimalSeparatorAlwaysShown(true);
        df.setRoundingMode(RoundingMode.HALF_UP);
        //En fonction du poids actuel de la commande, on applique le bon montant de livraison
        //Exprimé en g
        if (currentCommande.getPoidsTotal() > 30000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonSup30());
        } else if (currentCommande.getPoidsTotal() > 25000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax30());
        } else if (currentCommande.getPoidsTotal() > 20000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax25());
        } else if (currentCommande.getPoidsTotal() > 15000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax20());
        } else if (currentCommande.getPoidsTotal() > 10000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax15());
        } else if (currentCommande.getPoidsTotal() > 9000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax10());
        } else if (currentCommande.getPoidsTotal() > 8000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax9());
        } else if (currentCommande.getPoidsTotal() > 7000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax8());
        } else if (currentCommande.getPoidsTotal() > 6000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax7());
        } else if (currentCommande.getPoidsTotal() > 5000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax6());
        } else if (currentCommande.getPoidsTotal() > 4000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax5());
        } else if (currentCommande.getPoidsTotal() > 3000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax4());
        } else if (currentCommande.getPoidsTotal() > 2000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax3());
        } else if (currentCommande.getPoidsTotal() > 1000) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax2());
        } else if (currentCommande.getPoidsTotal() > 0) {
            currentCommande.setPrixLivraison(currentCommande.getPrixLivraisonMax1());
        }
        if (currentCommande.getPrixLivraison() > 0) {
            prixLivraison.setText(df.format(currentCommande.getPrixLivraison()+currentCommande.getPrixSupplementLivraison())+"€");
            livraisonLigne.setVisibility(View.VISIBLE);
        } else {
            prixLivraison.setText("0.00€");
            livraisonLigne.setVisibility(View.GONE);
        }
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

    }

    public Produit getProduit(int position) {
        return currentCommande.getListeProduit().get(position);
    }

    public Client getClient(int position) {
//        return currentCommande.getListeClients().get(position);
        return listeAllClients.get(position);
    }

    public Transporteur getTransporteur(int position) {
        return listeAllTransporteursFiltre.get(position);
    }

    public void changetab(View v) {
        effacerChampsRecherche();
        previousTab = actifTab;
        actifTab.setTextColor(getResources().getColor(R.color.colorBlanc));
        actifTab.setBackgroundResource(R.drawable.button_style);
        actifTab.setTypeface(null, Typeface.NORMAL);
        actifTab = ((TextView) v);
        actifTab.setTextColor(getResources().getColor(R.color.colorBlanc));
        actifTab.setBackgroundResource(R.drawable.button_style_selected);
        actifTab.setTypeface(null, Typeface.BOLD);
        selectedTab = Integer.parseInt(actifTab.getText().toString());

        if (listeCommande.get(selectedTab - 1) == null) {
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(commandeVide);
            //Mise à jour de la liste des transporteurs en fonction de la commande en cours
            mAdapterTransporteur.notifyDataSetChanged();
            recyclerView.setAdapter(mAdapter);
            recyclerViewTransporteurs.setAdapter(mAdapterTransporteur);
            recyclerView.setVisibility(View.INVISIBLE);
            recyclerViewTransporteurs.setVisibility(View.GONE);
            recyclerViewClients.setVisibility(View.GONE);
            messageFixe.setText("Créez une nouvelle commande!");
            messageFixe.setVisibility(View.VISIBLE);
        } else {
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(currentCommande);
            recyclerView.setAdapter(mAdapter);
            recyclerViewTransporteurs.setAdapter(mAdapterTransporteur);
            recyclerViewTransporteurs.setVisibility(View.GONE);
            recyclerViewClients.setVisibility(View.GONE);
            messageFixe.setText("");
            messageFixe.setVisibility(View.GONE);
        }

        afficheCommande();
    }

    @Override
    protected void onStop() {
        super.onStop();
        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();
        saveListeCommandes();

        if (mediaPlayer != null) {
            mediaPlayer.release();
        }
    }

    public void saveListeCommandes() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeCommande", gson.toJson(listeCommande)).apply();
    }

    public void getListeCommandes() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        String json = sharedPreferences.getString("listeCommande", null);
        if (json != null) {
            listeCommande = gson.fromJson(json, new TypeToken<List<Commande>>() {
            }.getType());
        }
    }

    public void afficheCommande() {
        filtreRechercheEnCours = false;
        currentCommande = listeCommande.get(selectedTab - 1);
        DecimalFormat df = new DecimalFormat("0.00");
        df.setMaximumFractionDigits(2);//arrondi à 2 chiffres après la virgule
        df.setMinimumFractionDigits(2);
        df.setDecimalSeparatorAlwaysShown(true);
        df.setRoundingMode(RoundingMode.HALF_UP);
        if (currentCommande != null) {
            if (messageFixe.getText().toString() == "Veuillez créer une nouvelle commmande pour commencer!") {
                messageFixe.setText("");
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setVisibility(View.GONE);
            }
            date.setText("Date: " + new SimpleDateFormat("dd-MM-yyyy", Locale.getDefault()).format(new Date()));
            num.setText("Cmd n°" + currentCommande.getNum());
            appliquerPrixLivraison();
            if (currentCommande.getNomClient() == "" || currentCommande.getNomClient() == null) {
                nom.setText("Invité");
                currentCommande.setIdClient("0");
                currentCommande.setCodePostalClient("");
            } else {
                nom.setText(currentCommande.getNomClient());
                currentCommande.setIdClient(currentCommande.getIdClient());
                currentCommande.setCodePostalClient(currentCommande.getCodePostalClient());
            }
            currentCommande.setNomTransporteur(currentCommande.getNomTransporteur());

            if (listeAllClients != null) {
                changerClient.setVisibility(View.VISIBLE);
            } else {
                changerClient.setVisibility(View.GONE);
            }

            textRemiseGlobale.setText("Remise (" + currentCommande.getRemiseGlobalePourcentage() + "%):");
            prixTotal.setText("" + (df.format(currentCommande.getPrixTotalAvecRemise()))+"€");
            remiseGlobaleTotal.setText("-" + (df.format(currentCommande.getRemiseTotal()))+"€");
            if (currentCommande.getRemiseGlobalePourcentage() != 0.0) {
                remiseGlobaleLigne.setVisibility(View.VISIBLE);
            } else {
                remiseGlobaleLigne.setVisibility(View.GONE);
            }

            if (currentCommande.getQtetotal() > 1) {
                qteTotal.setText("" + (currentCommande.getQtetotal()) + "pcs");
            } else {
                qteTotal.setText("" + (currentCommande.getQtetotal()) + "pc");
            }

            modeNom.setText(currentCommande.getNomTransporteur()+":");

            //Affiche remise globale
            if (currentCommande.getRemiseGlobalePourcentage() > 0) {
                remiseGlobaleLigne.setVisibility(View.VISIBLE);
            } else {
                remiseGlobaleLigne.setVisibility(View.GONE);
            }

            //Affiche en g ou en kg
            poidsTotal.setText(currentCommande.getPoidsTotalTxt());
            if (currentCommande.getPoidsTotal() > 0) {
                poidsTotalL.setVisibility(View.VISIBLE);
            } else {
                poidsTotalL.setVisibility(View.GONE);
            }

            //Affiche livraison
            if (currentCommande.getPrixSupplementLivraison() > 0 || currentCommande.getPrixLivraison() > 0) {
                livraisonLigne.setVisibility(View.VISIBLE);
            } else {
                livraisonLigne.setVisibility(View.GONE);
            }

            mAdapter.setCmd(currentCommande);
            mAdapter.notifyDataSetChanged();
            mAdapterTransporteur.notifyDataSetChanged();
            mAdapterClient.notifyDataSetChanged();

            fermerLesRecherches();
            recyclerViewClients.setVisibility(View.GONE);
            recyclerViewTransporteurs.setVisibility(View.GONE);
            recyclerView.setVisibility(View.VISIBLE);

            //PLANTE AU NIVEAU DE L'IMPRESSION
            try {
                new UpdateCommandeJSONAsyncTask().execute();
            } catch (Exception e) {
                e.printStackTrace();
            }
        } else {
            date.setText("");
            num.setText("");
            prixLivraison.setText("0.00€");
            modeNom.setText("En retrait:");
            nom.setText("");
            changerClient.setVisibility(View.GONE);
            prixTotal.setText("0,00€");
            poidsTotal.setText("0g");
            poidsTotalL.setVisibility(View.GONE);
            qteTotal.setText("0pc");
            remiseGlobaleTotal.setText("");
            textRemiseGlobale.setText("");
            remiseGlobaleLigne.setVisibility(View.GONE);
            messageFixe.setText("Veuillez créer une nouvelle commmande pour commencer!");
            messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
            messageFixe.setVisibility(View.VISIBLE);
        }
    }

    protected boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        return netInfo != null && netInfo.isConnectedOrConnecting();
    }

    public void nouvelleCommande(View v) {
        if (!synchronisationEnCours) {
            if (isOnline()) {
                effacerChampsRecherche();
                if (currentCommande != null) {
                    messageFixe.setText("");
                    messageFixe.setVisibility(View.GONE);
                    recyclerViewClients.setVisibility(View.GONE);
                    recyclerViewTransporteurs.setVisibility(View.GONE);
                    recyclerView.setVisibility(View.VISIBLE);
                    AlertDialog.Builder builder = new AlertDialog.Builder(this);
                    builder.setTitle("Voulez-vous réellement annuler cette commande ?");
                    builder.setMessage("Cette commande sera considérée comme annulée.");
                    DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            switch (which) {
                                case DialogInterface.BUTTON_POSITIVE:
                                    //Annulation
                                    dialog.dismiss();
                                    break;

                                case DialogInterface.BUTTON_NEGATIVE:
                                    try {
                                        NumeroDerniereCommandeAnnulee = currentCommande.getNum();
                                        new UpdateAnnulerCommandeAsyncTask().execute();
                                    } catch (Exception e) {
                                        e.printStackTrace();
                                    }

                                    dialog.dismiss();
                                    break;
                            }
                        }
                    };
                    builder.setPositiveButton("Annuler", dialogClickListener);
                    builder.setNegativeButton("Confirmer", dialogClickListener);
                    builder.show();
                } else {
                    messageFixe.setText("Créez une nouvelle commande pour commencer!");
                    messageFixe.setVisibility(View.GONE);
                    DateFormat dateFormat = new SimpleDateFormat("dd-MM-yyyy");
                    Date date = new Date();

                    newCommande = new Commande();
                    newCommande.setNomClient("Invité");
                    newCommande.setIdClient("0");
                    newCommande.setDate(dateFormat.format(date));
                    newCommande.setQtetotal(0);
                    newCommande.setPrixTotal(0.0);
                    newCommande.setRemiseGlobalePourcentage(0);
                    newCommande.setNomTransporteur("En retrait");
                    newCommande.setPrixLivraison(0.0);
                    textRemiseGlobale.setText("");
                    remiseGlobaleTotal.setText("0");
                    remiseGlobaleLigne.setVisibility(View.GONE);
                    newCommande.setId_operateur(MainActivity.id_operateur);
                    if (listeAllClients != null) {
                        changerClient.setVisibility(View.VISIBLE);
                    } else {
                        changerClient.setVisibility(View.GONE);
                    }
                    try {
                        new AddCommandeAsyncTask().execute();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            } else {
                Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
                CommandesActivity.this.startActivity(intent);
                CommandesActivity.this.overridePendingTransition(0, 0);
            }
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        nom.clearFocus();
        searchBar.clearFocus();
        searchBarClientCommande.clearFocus();

        IntentResult Result = IntentIntegrator.parseActivityResult(requestCode, resultCode, data);
        if (Result != null) {
            if (Result.getContents() == null) {
                afficherToast("KO", "Saisie annulée!");
            } else {
                updateData(Result.getContents());
            }
        } else {
            super.onActivityResult(requestCode, resultCode, data);
        }

        if (requestCode == 1) {
            if (resultCode == Activity.RESULT_OK) {
                Commande newC = data.getParcelableExtra("newC");
                listeCommande.set(selectedTab - 1, newC);
                currentCommande = listeCommande.get(selectedTab - 1);
                mAdapter.setCmd(currentCommande);
                recyclerView.setAdapter(mAdapter);
                recyclerViewTransporteurs.setAdapter(mAdapterTransporteur);
                afficheCommande();
            } else if (resultCode == Activity.RESULT_CANCELED) {
                if (listeCommande.get(0) == null && listeCommande.get(1) == null && listeCommande.get(2) == null && previousTab == null) {
                    finish();
                } else {
                    previousTab.callOnClick();
                }
            }
        } else if (requestCode == 3) {
            //Venant de FicheProduit
            if (resultCode == Activity.RESULT_OK) {
                Produit p = data.getParcelableExtra("produit");
                ajouterProduitCommande(p.getCode128(), p.getQte());
            } else if (resultCode == Activity.RESULT_CANCELED) {

            }
        } else if (requestCode == 4) {
            //Venant de RechercheActivity
            if (resultCode == Activity.RESULT_OK) {
                if (currentCommande != null) {
                    Produit p = data.getParcelableExtra("produit");
                    //Depuis fiche produit
                    ajouterProduitCommande(p.getCode128(), p.getQuantite_pack());
                } else {
                    afficherToast("KO", "Vous devez créer une nouvelle commande!");
                }

            } else if (resultCode == Activity.RESULT_CANCELED) {

            }
        } else if (requestCode == 5) {
            //Venant de la Ticket activity car fonction ré-imp
            if (resultCode == Activity.RESULT_OK) {
                //On ne fais rien car uniquement ré-impression maintenant
            } else if (resultCode == Activity.RESULT_CANCELED) {
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("Impossible d'imprimer la cmd "+commandeAImprimer.getNum());
                messageFixe.setVisibility(View.VISIBLE);
                //On ne fais rien car uniquement ré-impression maintenant
            }
            //Hors ligne
        } else if (requestCode == 6) {
            if (resultCode == Activity.RESULT_OK) {
                messageFixe.setBackgroundColor(getColor(R.color.colorVert));
                messageFixe.setText("Connexion internet rétablie!");
                messageFixe.setVisibility(View.VISIBLE);
            } else if (resultCode == Activity.RESULT_CANCELED) {
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("Connexion internet non rétablie!");
                messageFixe.setVisibility(View.VISIBLE);
            }
        } else if (requestCode == 7) {
            if (resultCode == Activity.RESULT_OK) {
                afficherToast("OK", "Ré-impression du ticket "+dernierTypeTicket+" effectué!");
            } else if (resultCode == Activity.RESULT_CANCELED) {
                afficherToast("KO","Ré-impression du ticket "+dernierTypeTicket+" non effectué!");
            }
        }

    }

    /* ZEBRA */
    @Override
    public void onOpened(EMDKManager emdkManager) {
        updateStatus("EMDK ouvert avec succès!");
        this.emdkManager = emdkManager;
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            initScanner();
            setDecoders();
            spinnerScannerDevices.setSelection(scannerIndex);
        }
    }

    /* ZEBRA */
    @Override
    protected void onResume() {
        super.onResume();

        //Désactiver le scanner toujours en scan
        scanEnPermanence = false;
        activerToujoursScanner.setBackgroundResource(R.drawable.barcode_scanner_manuel);
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (Exception e) {

                }
            }
        }

        if(!isOnline()) {
            Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
            CommandesActivity.this.startActivityForResult(intent, 5);
            CommandesActivity.this.overridePendingTransition(0, 0);
        }

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

        if (listeAllProduits == null) {
            try {
                synchronisation_manuelle = true;
                new GetAllProduitsAsyncTask().execute();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        // The application is in foreground
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            // Set selected scanner
            spinnerScannerDevices.setSelection(scannerIndex);
            // Initialize scanner
            initScanner();
        }

        currentCommande = listeCommande.get(selectedTab - 1);
        currentCommandeFiltre = listeCommande.get(selectedTab - 1);

        if (currentCommande != null) {
            messageFixe.setText("");
            messageFixe.setVisibility(View.GONE);
        }

    }

    @Override
    protected void onPause() {
        super.onPause();
        this.overridePendingTransition(0, 0);
        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();
    }

    /* ZEBRA */
    @Override
    public void onClosed() {
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
        updateStatus("Veuillez réinitialiser le scanner pour continuer!");
        //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
            messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
            messageFixe.setText("Veuillez réinitialiser le scanner pour continuer!");
            messageFixe.setVisibility(View.VISIBLE);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        saveListeCommandes();
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
    }

    @Override
    public void onData(ScanDataCollection scanDataCollection) {
        if ((scanDataCollection != null) && (scanDataCollection.getResult() == ScannerResults.SUCCESS)) {
            ArrayList<ScanDataCollection.ScanData> scanData = scanDataCollection.getScanData();
            for (ScanDataCollection.ScanData data : scanData) {
                updateData(data.getData());
            }
        }
    }

    public void onStatus(StatusData statusData) {
        ScannerStates state = statusData.getState();
        switch (state) {
            case IDLE:
                statusString = statusData.getFriendlyName() + " est prêt...";
                updateStatus(statusString);
                // set trigger type
                if (bSoftTriggerSelected) {
                    scanner.triggerType = TriggerType.SOFT_ONCE;
                    bSoftTriggerSelected = false; //Permet de passer au mode manuel
                } else {
                    if (scanEnPermanence) {
                        scanner.triggerType = TriggerType.SOFT_ALWAYS;
                    } else {
                        scanner.triggerType = TriggerType.HARD;
                    }
                }
                // set decoders
                if (bDecoderSettingsChanged) {
                    setDecoders();
                    bDecoderSettingsChanged = false;
                }
                // submit read
                if (!scanner.isReadPending() && !bExtScannerDisconnected) {
                    try {
                        if (scanEnPermanence) {
                            try {
                                Thread.sleep(1000); //Un temps d'attente de 1 seconde entre chaque scan
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }
                        }
                        scanner.read();
                    } catch (ScannerException e) {
                        updateStatus(e.getMessage());
                        //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
                    }
                }
                break;
            case WAITING:
                statusString = "Le lecteur de codes-barres est prêt pour utilisation!";
                updateStatus(statusString);
                break;
            case SCANNING:
                statusString = "Acquisition en cours...";
                updateStatus(statusString);
                break;
            case DISABLED:
                statusString = statusData.getFriendlyName() + " est indisponible.";
                updateStatus(statusString);
                break;
            case ERROR:
                statusString = "Une erreur s'est produite.";
                updateStatus(statusString);
                break;
            default:
                break;
        }
    }

    @Override
    public void onConnectionChange(ScannerInfo scannerInfo, ConnectionState connectionState) {
        String status;
        String scannerName = "";
        String statusExtScanner = connectionState.toString();
        String scannerNameExtScanner = scannerInfo.getFriendlyName();
        if (deviceList.size() != 0) {
            scannerName = deviceList.get(scannerIndex).getFriendlyName();
        }
        if (scannerName.equalsIgnoreCase(scannerNameExtScanner)) {
            switch (connectionState) {
                case CONNECTED:
                    bSoftTriggerSelected = false;
                    synchronized (lock) {
                        initScanner();
                        setDecoders();
                        bExtScannerDisconnected = false;
                    }
                    break;
                case DISCONNECTED:
                    bExtScannerDisconnected = true;
                    synchronized (lock) {
                        deInitScanner();
                    }
                    break;
            }
            status = scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        } else {
            bExtScannerDisconnected = false;
            status = statusString + " " + scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
    }

    private void initScanner() {
        if (scanner == null) {
            if ((deviceList != null) && (deviceList.size() != 0)) {
                if (barcodeManager != null) {
                    try {
                        scanner = barcodeManager.getDevice(deviceList.get(scannerIndex));
                    } catch (Exception e) {

                    }
                }
            } else {
                //reloadScanner = findViewById(R.id.reloadScanner);
                //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
                updateStatus("Failed to get the specified scanner device! Please close and restart the application.");
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("Veuillez réinitialiser le scanner pour continuer");
                messageFixe.setVisibility(View.VISIBLE);
                return;
            }
        } else if (scanner != null) {
            scanner.addDataListener(this);
            scanner.addStatusListener(this);
            try {
                scanner.enable();
                reloadScanner = findViewById(R.id.reloadScanner);
                reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload);
                if (!bSoftTriggerSelected)
                    scanner.triggerType = TriggerType.HARD;
                else
                    scanner.triggerType = TriggerType.SOFT_ALWAYS;
            } catch (ScannerException e) {
                //reloadScanner = findViewById(R.id.reloadScanner);
                //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
                updateStatus(e.getMessage());
                deInitScanner();
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("Veuillez redémarrer votre zebra"+"\n"+"lecteur code128 indisponible!");
                messageFixe.setVisibility(View.VISIBLE);
            }
        }
    }

    private void deInitScanner() {
        if (scanner != null) {
            try {
                scanner.disable();
                //reloadScanner = findViewById(R.id.reloadScanner);
                //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.removeDataListener(this);
                scanner.removeStatusListener(this);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.release();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            scanner = null;
        }
    }

    private void initBarcodeManager() {
        barcodeManager = (BarcodeManager) emdkManager.getInstance(FEATURE_TYPE.BARCODE);
        if (barcodeManager != null) {
            barcodeManager.addConnectionListener(this);
        }
    }

    private void deInitBarcodeManager() {
        if (emdkManager != null) {
            emdkManager.release(FEATURE_TYPE.BARCODE);
        }
    }

    private void addSpinnerScannerDevicesListener() {
        spinnerScannerDevices.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View arg1, int position, long arg3) {
                if ((scannerIndex != position) || (scanner == null)) {
                    scannerIndex = position;
                    bSoftTriggerSelected = false;
                    bExtScannerDisconnected = false;
                    deInitScanner();
                    initScanner();
                    setDecoders();
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });
    }

    private void enumerateScannerDevices() {
        if (barcodeManager != null) {
            List<String> friendlyNameList = new ArrayList<String>();
            int spinnerIndex = 0;
            deviceList = barcodeManager.getSupportedDevicesInfo();
            if ((deviceList != null) && (deviceList.size() != 0)) {
                Iterator<ScannerInfo> it = deviceList.iterator();
                while (it.hasNext()) {
                    ScannerInfo scnInfo = it.next();
                    friendlyNameList.add(scnInfo.getFriendlyName());
                    if (scnInfo.isDefaultScanner()) {
                        defaultIndex = spinnerIndex;
                    }
                    ++spinnerIndex;
                }
            } else {
                updateStatus("Failed to get the list of supported scanner devices! Please close and restart the application.");
//                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                ///              messageFixe.setText("Veuillez redémarrer votre zebra\"+\"\\n\"+\"lecteur code128 indisponible!");
                //           messageFixe.setVisibility(View.VISIBLE);
            }
            ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(CommandesActivity.this, android.R.layout.simple_spinner_item, friendlyNameList);
            spinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinnerScannerDevices.setAdapter(spinnerAdapter);
        }
    }

    private void setDecoders() {
        if (scanner != null) {
            try {
                ScannerConfig config = scanner.getConfig();

                try {
                    //PASSER LA FREQUENCE A 10000MS (1 seconde) PAR SCAN
                    //config.readerParams.readerSpecific.imagerSpecific.aimType = ScannerConfig.AimType.CONTINUOUS_READ;
                    config.readerParams.readerSpecific.imagerSpecific.aimType = ScannerConfig.AimType.TRIGGER;
                    config.readerParams.readerSpecific.imagerSpecific.sameSymbolTimeout = 3000;
                    config.readerParams.readerSpecific.imagerSpecific.differentSymbolTimeout = 1500;


                    //DESACTIVE LE SON DU BEEP PAR DEFAUT
                    //config.scanParams.decodeAudioFeedbackUri = "content://fr.itsee.zelyx.assets/silence.mp3";
                    config.scanParams.decodeAudioFeedbackMode = ScannerConfig.DecodeAudioFeedbackMode.DISABLE;
                    config.scanParams.decodeHapticFeedback = false;
                    config.scanParams.decodeAudioFeedbackUri = "";

                    //AFFICHE LED QUAND SCAN
                    config.scanParams.decodeLEDFeedbackMode = ScannerConfig.DecodeLEDFeedbackMode.LOCAL;
                    config.scanParams.decodeLEDFeedback = true;

                    //AUTORISE QUE LES CODES 128
                    config.decoderParams.ean8.enabled = false;
                    config.decoderParams.ean13.enabled = false;
                    config.decoderParams.code39.enabled = false;
                    config.decoderParams.code128.enabled = true;
                    //APPLIQUER LES PARAMETRES
                    scanner.setConfig(config);
                } catch (Exception e) {
                }

            } catch (ScannerException e) {
                updateStatus(e.getMessage());
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("Veuillez redémarrer votre zebra\nlecteur code128 indisponible!");
                messageFixe.setVisibility(View.VISIBLE);
            }
        }
    }

    private void cancelRead() {
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                }
            }
        }
    }

    private void updateStatus(final String status) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textViewStatus.setText("" + status);
            }
        });
    }

    //Traitement après chaque scan
    private void updateData(final String result) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (result != null) {
                    //Si liste de produits inexistant, je recharge
                    if (listeAllProduits != null && listeAllClients != null && listeAllTransporteurs != null) {
                        Produit p = getProduitFromCode128(result);
                        if (p != null && currentCommande != null) {
                            //cptFlashProduit++;
                            try {
                                Thread.sleep(1000); //Un temps d'attente de 1 seconde entre chaque scan
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }
                            ajouterProduitCommande(p.getCode128(), p.getQuantite_pack());
                            //afficherToast("OK", "Ajout "+p.getCode128()+" qtePack:"+p.getQuantite_pack()+" nbreFlash:"+cptFlashProduit+"!");
                        } else if (currentCommande == null) {
                            afficherToast("KO", "Vous devez créer une nouvelle commande!");
                        } else if (p == null) {
                            afficherToast("NEXISTEPAS", "Cet article n'existe pas!");
                        }
                    } else {
                        afficherToast("KO", "Veuillez attendre la fin de la synchronisation pour continuer!");
                    }
                }
            }
        });
    }

    public Produit getProduitFromCode128(String code128) {
        try {
            if (listeAllProduits != null) {
                for (Produit p : listeAllProduits) {
                    if (p.getCode128().equals(code128)) {
                        return p;
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static TransporteurChronopostFranceSupplement getSupplementTransporteurChronospostFrance(String code_postal) {
        try {
            if (listeAllSupplementTransporteurChronopostFrance != null) {
                for (TransporteurChronopostFranceSupplement ts : listeAllSupplementTransporteurChronopostFrance) {
                    if (ts.getCodePostalLivraison().equals(code_postal)) {
                        return ts;
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public void ajouterProduitCommande(String code128, Integer qteProduit) {
        if (listeAllProduits != null) {
            int i = 0;
            int max = listeAllProduits.size();
            //BUG ICI, si trouve plusieurs fois le meme code128 les additionnes
            while (!listeAllProduits.get(i).getCode128().equals(code128) && i < max - 1) {
                i += 1;
                break; //Sortir de la boucle dès trouvé //Débug du 20230108
            }
            if (i < max) {//si le produit existe dans la base de donnees
                int j = 0;
                int nbrProduitCommande = currentCommande.getListeProduit().size();
                Produit p = listeAllProduits.get(i);

                while (nbrProduitCommande > 0 && !currentCommande.getListeProduit().get(j).getCode128().equals(p.getCode128()) && j < nbrProduitCommande - 1) {
                    j += 1;//Sortir de la boucle dès trouvé //Débug du 20230108
                    break;
                }

                int qte;
                if (currentCommande.getListeProduit().size() != 0) {
                    qte = currentCommande.getListeProduit().get(j).getQte();
                } else {
                    qte = 0;
                }

                int reste = p.getStock() - qte - p.getQte();

                if (j != nbrProduitCommande && nbrProduitCommande != 0 && currentCommande.getListeProduit().get(j).getCode128().equals(p.getCode128())) {
                    if (reste <= 0) {
                        afficherToast("NEXISTEPAS", "Stock null " + currentCommande.getListeProduit().get(j).getRef() + " " + currentCommande.getListeProduit().get(j).getColoris() + " !");//currentCommande.getListeProduit().get(j).incQte();
                        int nouvelleQte = currentCommande.getListeProduit().get(j).getQte() + qteProduit;
                        Produit nouvelleQteProduit = currentCommande.getListeProduit().get(j);
                        nouvelleQteProduit.setQte(nouvelleQte);
                        currentCommande.delProduit(currentCommande.getListeProduit().get(j));
                        currentCommande.addProduit(nouvelleQteProduit);
                    } else {
                        int nouvelleQte = currentCommande.getListeProduit().get(j).getQte() + qteProduit;
                        Produit nouvelleQteProduit = currentCommande.getListeProduit().get(j);
                        nouvelleQteProduit.setQte(nouvelleQte);
                        currentCommande.delProduit(currentCommande.getListeProduit().get(j));
                        currentCommande.addProduit(nouvelleQteProduit);
                        jouerSon("ajoutProduit.mp3");
                    }
                } else {
                    if (reste <= 0) {
                        afficherToast("NEXISTEPAS", "Stock null " + currentCommande.getListeProduit().get(j).getRef() + " " + currentCommande.getListeProduit().get(j).getColoris() + " !");
                        Produit newProduit = new Produit(p);
                        newProduit.setQte(1);
                        currentCommande.addProduit(newProduit);
                    } else {
                        Produit newProduit = new Produit(p);
                        newProduit.setQte(p.getQte());
                        currentCommande.addProduit(newProduit);
                        jouerSon("ajoutProduit.mp3");
                    }
                }
                afficheCommande();
            } else {
                afficherToast("NEXISTEPAS", "Cet article n'existe pas!");
            }
        } else {
            afficherToast("KO", "Veuillez attendre la fin de la synchronisation pour continuer!");
        }
    }

    public void effacerChampsRecherche() {
        image_produit_full.setVisibility(View.GONE);
        searchBar.setQuery("", false);
        searchBar.setIconified(true);
        searchBarProduitCommande.setQuery("", false);
        searchBarProduitCommande.setIconified(true);
        searchBarClientCommande.setQuery("", false);
        searchBarProduitCommande.setIconified(true);
        searchBarTransporteurCommande.setQuery("", false);
        searchBarClientCommande.setIconified(true);
    }

    /* ZEBRA */
    @Override
    public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
        bDecoderSettingsChanged = true;
        cancelRead();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    //Masquer le clavier quand on appuie en dehors du champ
    @Override
    public boolean dispatchTouchEvent(MotionEvent ev) {
        if (getCurrentFocus() != null) {
            InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);
        }
        return super.dispatchTouchEvent(ev);
    }

    public void faireRecherche(String valeur) {
        resultatRecherche = new ArrayList<>();
        if (!currentCommande.getListeProduit().isEmpty()) {
            Commande currentCommandeFiltre = new Commande();
            if (valeur.toLowerCase() != "") {
                for (Produit p : currentCommande.getListeProduit()) {
                    //Recherche sur la référence, couleur, catégorie, informations (nom catégorie) et non code 128
                    /*if (!p.getCode128().isEmpty() && p.getCode128().toLowerCase().contains(valeur.toLowerCase())) {
                        currentCommandeFiltre.addProduit(p);
                    } else*/ if (!p.getRef().isEmpty() && p.getRef().toLowerCase().contains(valeur.toLowerCase())) {
                        currentCommandeFiltre.addProduit(p);
                    } else if (!p.getColoris().isEmpty() && p.getColoris().toLowerCase().contains(valeur.toLowerCase())) {
                        currentCommandeFiltre.addProduit(p);
                    } /*else if (!p.getInformations().isEmpty() && p.getInformations().toLowerCase().contains(valeur.toLowerCase())) {
                        currentCommandeFiltre.addProduit(p);
                    } else if (!p.getNumCategorie().isEmpty() && p.getNumCategorie().toLowerCase().contains(valeur.toLowerCase())) {
                        currentCommandeFiltre.addProduit(p);
                    }*/
                }
            } else {
                filtreRechercheEnCours = false;
            }
            if (currentCommandeFiltre.getQtetotal() == 0) {
                currentCommandeFiltre = currentCommande; //Remise à 0 si pas trouvé
                Toast.makeText(getApplicationContext(), "Aucun résultat", Toast.LENGTH_SHORT).show();
            } else {
                currentCommandeFiltre = currentCommandeFiltre;
            }
            mAdapter.setCmd(currentCommandeFiltre);
        }
    }

    public void faireRechercheClients(String valeur) {
        resultatRechercheClients = new ArrayList<>();
        if (!listeAllClients.isEmpty() && listeAllClients != null) {
            listeAllClientsFiltre = new ArrayList<Client>();
            if (valeur.toLowerCase() != "" && valeur.length() > 2) {
                for (Client c : listeAllClients) {
                    //Recherche sur le nom entreprise, nom, prenom, siren, telephone, telephone2
                    if (!c.getNomEntreprise().isEmpty() && c.getNomEntreprise().toLowerCase().contains(valeur.toLowerCase())) {
                        listeAllClientsFiltre.add(c);
                    } else if (!c.getNom().isEmpty() && c.getNom().toLowerCase().contains(valeur.toLowerCase())) {
                        listeAllClientsFiltre.add(c);
                    } else if (!c.getSiren().isEmpty() && c.getSiren().contains(valeur.toLowerCase())) {
                        listeAllClientsFiltre.add(c);
                    } else if (!c.getTelephone().isEmpty() && c.getTelephone().contains(valeur.toLowerCase())) {
                        listeAllClientsFiltre.add(c);
                    } else if (!c.getTelephone2().isEmpty() && c.getTelephone2().contains(valeur.toLowerCase())) {
                        listeAllClientsFiltre.add(c);
                    }
                }
            } else {
                filtreRechercheEnCours = false;
            }
            //Affiche tout si non trouvé
            if (listeAllClientsFiltre.size() == 0) {
                listeAllClientsFiltre = listeAllClients; //Remise à 0 si pas trouvé
            }
            mAdapterClient.notifyDataSetChanged();
        }
    }

    public void faireRechercheTransporteurs(String valeur) {
        resultatRechercheTransporteurs = new ArrayList<>();
        if (!listeAllTransporteurs.isEmpty() && currentCommande != null) {
            listeAllTransporteursFiltre = new ArrayList<Transporteur>();
            if (valeur.toLowerCase() != "" && valeur.length() > 2 && currentCommande != null) {
                try {
                    for (Transporteur t : listeAllTransporteurs) {
                        //Recherche sur le nom transporteur
                        if (!t.getNomTransporteur().isEmpty() && t.getNomTransporteur().toLowerCase().contains(valeur.toLowerCase())) {
                            listeAllTransporteursFiltre.add(t);
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            } else {
                filtreRechercheEnCours = false;
            }
            //Affiche tout si non trouvé
            if (currentCommande != null && listeAllTransporteursFiltre.size() == 0) {
                listeAllTransporteursFiltre = listeAllTransporteurs;
            }
            mAdapterTransporteur.notifyDataSetChanged();
        }
    }

    private class UpdateAControlerCommandeAsyncTask extends AsyncTask<String, String, String> {
        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;

        @Override
        protected String doInBackground(String... params) {
            if (commandeAImprimer != null) {
                HttpJsonParser httpJsonParser3 = new HttpJsonParser();
                Map<String, String> httpParams3 = new HashMap<>();
                httpParams3.put("numero_commande", ""+commandeAImprimer.getNum());
                JSONObject jsonObject3 = httpJsonParser3.makeHttpRequest(
                        BASE_URL + "updateAControlerCommande.php", "POST", httpParams3);
                try {
                    success = jsonObject3.getInt("success");
                    if (success != 1 ) {
                        return "La commande "+commandeAImprimer.getNum()+" n'est pas passé en statut à contrôler!";
                    }
                } catch (JSONException e) {
                    return "La commande "+commandeAImprimer.getNum()+" n'est pas passé en statut à contrôler!";
                } catch (Exception e) {
                    return "La commande "+commandeAImprimer.getNum()+" n'est pas passé en statut à contrôler!";
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (s == null) {
                //Uniquement déstockage si la commande en cours est imprimée
                if (commandeAImprimer.getNum() == currentCommande.getNum()) {
                    try {
                        //Même si erreur déstocker le produit
                        new DestockageProduitsJSONAsyncTask().execute();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
        }
    }

    public class UpdateAnnulerCommandeAsyncTask extends AsyncTask<String, String, String> {
        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;

        @Override
        protected String doInBackground(String... params) {
            //if (NumeroDerniereCommandeAnnulee != "0") {
            try {
                HttpJsonParser httpJsonParser3 = new HttpJsonParser();
                Map<String, String> httpParams3 = new HashMap<>();
                httpParams3.put("numero_commande", ""+NumeroDerniereCommandeAnnulee);
                JSONObject jsonObject3 = httpJsonParser3.makeHttpRequest(
                        BASE_URL + "updateAnnulerCommande.php", "POST", httpParams3);
                success = jsonObject3.getInt("success");
                if (success != 1) {
                    return jsonObject3.getString("message");
                }
            } catch (JSONException e) {
                return "La commande "+NumeroDerniereCommandeAnnulee+" n'est pas passée en statut annulé!";
            } catch (Exception e) {
                return "La commande "+NumeroDerniereCommandeAnnulee+" n'est pas passée en statut annulé!";
            }
            //}
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (s != null) {
                //Affiche la message d'erreur
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText(s);
                messageFixe.setVisibility(View.VISIBLE);
            } else {
                //Affiche la confirmation d'annulation
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("La commande " + NumeroDerniereCommandeAnnulee + " est passée en statut annulé");
                messageFixe.setVisibility(View.VISIBLE);
            }
            //Une fois le traitement terminé on repasse à 0 la valeur.
            NumeroDerniereCommandeAnnulee = "0";

            //Affiche une commande vide après déstockage
            listeCommande.set(selectedTab - 1, null);
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(commandeVide);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
        }

    }

    public class UpdateCommandeJSONAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            currentCommande.getPoidsTotal();
            appliquerPrixLivraison();
        }

        @Override
        protected String doInBackground(String... params) {
            if (currentCommande != null && currentCommande.getNum() != "" && !currentCommande.getListeProduit().isEmpty()) {
                try {
                    Gson gson = new Gson();
                    String json_produits = "";
                    try {
                        json_produits = gson.toJson(currentCommande.getListeProduit());
                    } catch (Exception e) {
                        return "Impossible de mettre à jour la commande!";
                    }

                    if (json_produits != "") {
                        HttpJsonParser httpJsonParser1 = new HttpJsonParser();
                        Map<String, String> httpParams1 = new HashMap<>();
                        httpParams1.put("numero_commande", "" + currentCommande.getNum());
                        httpParams1.put("nom_client", "" + currentCommande.getNomClient());
                        httpParams1.put("nom_transporteur", "" + currentCommande.getNomTransporteur());
                        httpParams1.put("id_client", "" + currentCommande.getIdClient());
                        httpParams1.put("date", "" + currentCommande.getDate());
                        httpParams1.put("poids_commande", "" + currentCommande.getPoidsTotal());
                        httpParams1.put("total_fdp_ht", "" + currentCommande.getPrixLivraison());
                        httpParams1.put("sup_fdp_ht", "" + currentCommande.getPrixSupplementLivraison());
                        httpParams1.put("total_ht", "" + currentCommande.getPrixTotalAvecRemise());
                        httpParams1.put("qte_produits", "" + currentCommande.getQtetotal());
                        httpParams1.put("remise_ht", "" + currentCommande.getRemiseTotal());
                        httpParams1.put("liste_produits", "" + json_produits);
                        httpParams1.put("initiales_boutique", "" + MainActivity.code_boutique);
                        httpParams1.put("id_operateur", "" + currentCommande.getId_operateur());
                        httpParams1.put("total_produits_ht", "" + (currentCommande.getPrixTotal() + currentCommande.getPrixLivraison() + currentCommande.getPrixSupplementLivraison()));
                        JSONObject jsonObject1 = httpJsonParser1.makeHttpRequest(
                                BASE_URL + "updateCommandeJSON.php", "POST", httpParams1);
                        success = jsonObject1.getInt("success");
                        //Si maj effectué
                        if (success == 1) {
                            //Mis à jour
                        }
                    }
                } catch (JSONException e) {
                    return "Impossible de mettre à jour la commande!";
                } catch (Exception e) {
                    return "Impossible de mettre à jour la commande!";
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            /*if (s != null) {
                afficherToast("KO", s);
            }*/
        }
    }

    private class GetAllProduitsAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            syncButton.setBackground(getResources().getDrawable(R.drawable.button_style_selected));
            syncButton.setTypeface(null, Typeface.BOLD);
            syncButton.setEnabled(false);
            //searchBar.setEnabled(false);
            if (synchronisation_manuelle) {
                synchronisation_en_cours.setVisibility(View.VISIBLE);
                synchronisationEnCours = true;
            }
        }

        @Override
        protected String doInBackground(String... params) {
            if (listeAllProduits == null) {
                HttpJsonParser httpJsonParser = new HttpJsonParser();
                JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                        BASE_URL + "listeProduits.php", "GET", null);
                List<Produit> produitList = new ArrayList<>();
                try {
                    int success = jsonObject.getInt("success");
                    JSONArray produits;
                    if (success == 1) {
                        produits = jsonObject.getJSONArray("data");
                        for (int i = 0; i < produits.length(); i++) {
                            Produit p = new Produit();
                            JSONObject produit = produits.getJSONObject(i);
                            try {
                                p.setRef(produit.getString("reference"));
                                p.setColoris(produit.getString("coloris"));
                                p.setCommandable(produit.getString("commandable"));
                                p.setCode128(produit.getString("code_128"));
                                p.setQuantite_pack(produit.getInt("quantite_packs"));
                                p.setPrix(produit.getDouble("prix"));
                                p.setPrixPromo(produit.getDouble("prix_promo"));
                                if (produit.getDouble("prix_promo") < produit.getDouble("prix") && produit.getDouble("prix_promo") > 0) {
                                    p.setSiPromo(1);
                                } else {
                                    p.setSiPromo(0);
                                }
                                p.setStock(produit.getInt("stock"));
                                p.setPoids(produit.getDouble("poids"));
                                p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                p.setInformations(produit.getString("informations"));
                                p.setLien_image(produit.getString("lien_image"));
                                p.setActif(produit.getInt("actif"));
                                p.setQteTotalRef(produit.getInt("qte_total_ref"));
                                p.setQte(produit.getInt("quantite_packs"));
                                p.setSiPromo(0);
                                p.setNumCategorie(produit.getString("num_categorie"));
                                p.setSeuilMin(produit.getInt("seuil_min"));
                                p.setSeuilMax(produit.getInt("seuil_max"));
                                p.setPrixCatalogue(produit.getDouble("prix"));
                                produitList.add(p);
                            } catch (Exception e) {
                                return "Impossible de récupérer un article!";
                            }
                        }
                        listeAllProduits = produitList;
                    }
                } catch (JSONException e) {
                    return "Impossible de récupérer les articles!";
                } catch (Exception e) {
                    return "Impossible de récupérer les articles!";
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (s != null) {
                synchronisation_en_cours.setVisibility(View.GONE);
                synchronisationEnCours = false;
            }
            syncButton.setBackground(getResources().getDrawable(R.drawable.button_style));
            syncButton.setTypeface(null, Typeface.NORMAL);
            syncButton.setEnabled(true);
            //searchBar.setEnabled(true);

            //Lancé après chargement des produits
            if (MainActivity.code_boutique != null) {
                new GetAllClientsAsyncTask().execute();
                new GetAllTransporteurSupplementChronopostFranceAsyncTask().execute();
            }
            if (CommandesActivity.listeAllClientsFiltre != null && CommandesActivity.listeAllTransporteurs != null) {
                synchronisation_en_cours.setVisibility(View.GONE);
                synchronisationEnCours = false;
            }
            if (currentCommande == null) {
                nom.setText("");
                messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
                messageFixe.setText("Veuillez créer une nouvelle commande pour commencer!");
                messageFixe.setVisibility(View.VISIBLE);
            } else {
                if (currentCommande.getNomClient() == "") {
                    nom.setText("Invité");
                    currentCommande.setIdClient("0");
                    currentCommande.setCodePostalClient("");
                } else {
                    nom.setText(currentCommande.getNomClient());
                }
                messageFixe.setText("");
                messageFixe.setVisibility(View.GONE);
            }

            if (affichelisteclients == 0 && affichelistetransporteurs == 0) {
                recyclerView.setVisibility(View.VISIBLE);
            }

            if (listeAllProduits.isEmpty()) {
                //afficherToast("KO", "Impossible de charger les articles!");
                messageFixe.setText("Impossible de charger les articles!");
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setVisibility(View.VISIBLE);
            } /*else {
                messageFixe.setText("");
                messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
                messageFixe.setVisibility(View.GONE);
            }*/

            synchronisation_manuelle = true;

            // The application is in foreground
            if (emdkManager != null) {
                // Acquire the barcode manager resources
                initBarcodeManager();
                // Enumerate scanner devices
                enumerateScannerDevices();
                // Set selected scanner
                spinnerScannerDevices.setSelection(scannerIndex);
                // Initialize scanner
                initScanner();
            }
            //Fermer le clavier
            hideKeyboard(CommandesActivity.this);
            /*if (getCurrentFocus() != null) {
                InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);
            }*/
        }
    }

    private class GetAllClientsAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            changerClient.setVisibility(View.GONE);
        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams1 = new HashMap<>();
            httpParams1.put("code_boutique", ""+MainActivity.code_boutique);
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeClients.php", "GET", httpParams1);

            List<Client> clientList = new ArrayList<>();
            try {
                int success = jsonObject.getInt("success");
                JSONArray clients;
                if (success == 1) {
                    clients = jsonObject.getJSONArray("clients");
                    String siIdPays = null;
                    for (int i = 0; i < clients.length(); i++) {
                        siIdPays = null;
                        Client c = new Client();
                        JSONObject client = clients.getJSONObject(i);
                        try {
                            c.setId(client.getString("id"));
                            c.setNomEntreprise(client.getString("nom_entreprise"));
                            c.setSiren(client.getString("siren"));
                            c.setNom(client.getString("nom"));
                            c.setPrenom(client.getString("prenom"));
                            c.setTelephone(client.getString("telephone"));
                            c.setTelephone2(client.getString("telephone2"));
                            c.setAdresse(client.getString("adresse"));
                            c.setAdresse2(client.getString("adresse2"));
                            c.setCp(client.getString("cp"));
                            c.setVille(client.getString("ville"));
                            c.setPays(client.getString("pays"));

                            //Bug au niveau de l'id du pays
                            siIdPays = client.getString("id_pays");
                            if (siIdPays != null && !siIdPays.isEmpty()) {
                                c.setIdPays(client.getInt("id_pays"));
                            } else {
                                c.setIdPays(0);
                            }
                            clientList.add(c);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                    listeAllClients = clientList;
                    listeAllClientsFiltre = clientList;
                } else {
                    afficherToast("KO", "Impossible de charger les clients!");
                }

            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (s != null) {
                synchronisation_en_cours.setVisibility(View.GONE);
                synchronisationEnCours = false;
            }
            changerClient.setVisibility(View.VISIBLE);
            if (listeAllClients != null && listeAllClients.isEmpty()) {
                synchronisation_en_cours.setVisibility(View.GONE);
                synchronisationEnCours = false;
                afficherToast("KO", "Impossible de charger les clients!");
            }
            if (CommandesActivity.listeAllClientsFiltre != null && CommandesActivity.listeAllTransporteurs != null) {
                synchronisation_en_cours.setVisibility(View.GONE);
                synchronisationEnCours = false;
            }
        }
    }

    private class GetAllTransporteursAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams1 = new HashMap<>();
            httpParams1.put("code_boutique", ""+MainActivity.code_boutique);
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeTransporteurs.php", "GET", httpParams1);
            List<Transporteur> transporteurList = new ArrayList<>();
            try {
                int success = jsonObject.getInt("success");
                JSONArray transporteurs;
                if (success == 1) {
                    transporteurs = jsonObject.getJSONArray("transporteurs");
                    for (int i = 0; i < transporteurs.length(); i++) {
                        Transporteur t = new Transporteur();
                        JSONObject transporteur = transporteurs.getJSONObject(i);
                        try {
                            t.setId(parseInt(transporteur.getString("id")));
                            t.setNom_transporteur(transporteur.getString("nom"));
                            t.setMax1(parseDouble(transporteur.getString("max1")));
                            t.setMax2(parseDouble(transporteur.getString("max2")));
                            t.setMax3(parseDouble(transporteur.getString("max3")));
                            t.setMax4(parseDouble(transporteur.getString("max4")));
                            t.setMax5(parseDouble(transporteur.getString("max5")));
                            t.setMax6(parseDouble(transporteur.getString("max6")));
                            t.setMax7(parseDouble(transporteur.getString("max7")));
                            t.setMax8(parseDouble(transporteur.getString("max8")));
                            t.setMax9(parseDouble(transporteur.getString("max9")));
                            t.setMax10(parseDouble(transporteur.getString("max10")));
                            t.setMax15(parseDouble(transporteur.getString("max15")));
                            t.setMax20(parseDouble(transporteur.getString("max20")));
                            t.setMax25(parseDouble(transporteur.getString("max25")));
                            t.setMax30(parseDouble(transporteur.getString("max30")));
                            t.setSup30(parseDouble(transporteur.getString("sup30")));
                            t.setDetailsTransporteur(transporteur.getString("description"));
                            transporteurList.add(t);
                        } catch (Exception e) {
                            return "Impossible de charger complètement les transporteurs!";
                        }
                    }
                    listeAllTransporteurs = transporteurList;
                    listeAllTransporteursFiltre = transporteurList;
                } else {
                    return "Impossible de charger les transporteurs!";
                }
            } catch (JSONException e) {
                return "Impossible de charger les transporteurs!";
            } catch (Exception e) {
                return "Impossible de charger les transporteurs!";
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            mAdapterTransporteur.notifyDataSetChanged();
            if (s != null) {
                synchronisation_en_cours.setVisibility(View.GONE);
                synchronisationEnCours = false;
                //afficherToast("KO", s);
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText(s);
                messageFixe.setVisibility(View.VISIBLE);
                //afficherToast("KO", "erreur transp"+s);
            }
            if (CommandesActivity.listeAllClientsFiltre != null && CommandesActivity.listeAllTransporteurs != null) {
                synchronisation_en_cours.setVisibility(View.GONE);
                synchronisationEnCours = false;
            }
        }
    }

    private class GetAllTransporteurSupplementChronopostFranceAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams1 = new HashMap<>();
            httpParams1.put("code_boutique", ""+MainActivity.code_boutique);
            //Pas de paramètres de recherche
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "getSupplementTransporteurChronopostFrance.php", "GET", httpParams1);
            try {
                int success = jsonObject.getInt("success");
                JSONArray transporteurs;
                if (success == 1) {
                    List<TransporteurChronopostFranceSupplement> transporteurChronopostFranceSupplementList = new ArrayList<>();
                    transporteurs = jsonObject.getJSONArray("transporteurs");
                    for (int i = 0; i < transporteurs.length(); i++) {
                        TransporteurChronopostFranceSupplement ts = new TransporteurChronopostFranceSupplement();
                        JSONObject transporteurChronopostFranceSupplement = transporteurs.getJSONObject(i);
                        try {
                            ts.setId (transporteurChronopostFranceSupplement.getInt("id_transporteur"));
                            ts.setSupplement_transporteur(transporteurChronopostFranceSupplement.getDouble("supplement"));
                            ts.setCodePostalLivraison(transporteurChronopostFranceSupplement.getString("code_postal"));
                            transporteurChronopostFranceSupplementList.add(ts);
                        } catch (Exception e) {
                            return "Impossible de récupérer les suppléments transporteur chronopost France!";
                        }
                    }
                    listeAllSupplementTransporteurChronopostFrance = transporteurChronopostFranceSupplementList;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);

            if (s != null) {
                synchronisation_en_cours.setVisibility(View.GONE);
                synchronisationEnCours = false;
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText(""+s);
                messageFixe.setVisibility(View.VISIBLE);
            } else if (listeAllSupplementTransporteurChronopostFrance == null) {
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("Impossible de récupérer les suppléments transporteur chronopost France!");
                messageFixe.setVisibility(View.VISIBLE);
            } else {
                   //Charge les transporteurs après chronopost france supplément
                    new GetAllTransporteursAsyncTask().execute();
            }

        }
    }

    public class DestockageProduitsJSONAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            if (commandeAImprimer != null && commandeAImprimer.getNum() != "" && !commandeAImprimer.getListeProduit().isEmpty()) {
                try {
                    Gson gson = new Gson();
                    String json_produits = "";
                    try {
                        json_produits = gson.toJson(currentCommande.getListeProduit());
                    } catch (Exception e) {
                        return "Impossible de mettre à jour la commande!";
                    }
                    if (json_produits != "") {
                        HttpJsonParser httpJsonParser1 = new HttpJsonParser();
                        Map<String, String> httpParams1 = new HashMap<>();
                        httpParams1.put("numero_commande", "" + commandeAImprimer.getNum());
                        httpParams1.put("nom_client", "" + commandeAImprimer.getNomClient());
                        httpParams1.put("nom_transporteur", "" + commandeAImprimer.getNomTransporteur());
                        httpParams1.put("id_client", "" + commandeAImprimer.getIdClient());
                        httpParams1.put("date", "" + commandeAImprimer.getDate());
                        httpParams1.put("poids_commande", "" + commandeAImprimer.getPoidsTotal());
                        httpParams1.put("total_fdp_ht", "" + commandeAImprimer.getPrixLivraison());
                        httpParams1.put("sup_fdp_ht", "" + commandeAImprimer.getPrixSupplementLivraison());
                        httpParams1.put("total_ht", "" + commandeAImprimer.getPrixTotalAvecRemise());
                        httpParams1.put("qte_produits", "" + commandeAImprimer.getQtetotal());
                        httpParams1.put("remise_ht", "" + commandeAImprimer.getRemiseTotal());
                        httpParams1.put("liste_produits", "" + json_produits);
                        httpParams1.put("initiales_boutique", "" + MainActivity.code_boutique);
                        httpParams1.put("id_operateur", "" + commandeAImprimer.getId_operateur());
                        httpParams1.put("total_produits_ht", "" + (commandeAImprimer.getPrixTotal() + commandeAImprimer.getPrixLivraison() + commandeAImprimer.getPrixSupplementLivraison()));
                        JSONObject jsonObject1 = httpJsonParser1.makeHttpRequest(
                                BASE_URL + "destockageProduitsJSON.php", "POST", httpParams1);
                        success = jsonObject1.getInt("success");
                        //Si maj effectué
                        if (success == 1) {
                            //Mis à jour
                        }
                    } else {
                        return "Impossible de déstocker les produits de la commande!";
                    }
                } catch (JSONException e) {
                    return "Impossible de déstocker les produits de la commande!";
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (s != null) {
                afficherToast("KO", s);
                messageFixe.setText(s);
                messageFixe.setVisibility(View.VISIBLE);
            } else {
                //Puis on vide la commande actuelle
                //Affiche une commande vide après déstockage
                listeCommande.set(selectedTab - 1, null);
                currentCommande = listeCommande.get(selectedTab - 1);
                mAdapter.setCmd(commandeVide);
                recyclerView.setAdapter(mAdapter);
                afficheCommande();
            }
        }
    }

    public class RefreshStockProduitAsyncTask extends AsyncTask<Produit, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;
        @Override
        protected String doInBackground(Produit... produits) {
            Produit p = produits[0];
            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();
            httpParams2.put("code_128", ""+p.getCode128());
            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "getStockProduit.php", "GET", httpParams2);
            try {
                success = jsonObject2.getInt("success");
                if (success == 1) {
                    JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                    p.setStock(Integer.parseInt(produit.getString("stock")));
                } else {
                    return "Impossible de mettre à jour le stock l'article "+p.getRef()+" "+p.getColoris()+"!";
                }
            } catch (JSONException e) {
                return "Impossible de mettre à jour le stock de l'article "+p.getRef()+" "+p.getColoris()+"!";
            } catch (Exception e) {
                return "Impossible de mettre à jour le stock de l'article "+p.getRef()+" "+p.getColoris()+"!";
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (s!= null) {
                afficherToast("KO", s);
            } else {
                mAdapter.notifyDataSetChanged();
            }
        }
    }

    private class AddCommandeAsyncTask extends AsyncTask<String, String, String> {
        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;
        private ProgressDialog waiting;
        int nbrCommandeParDate, nbrCommandesAjd = 0;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            waiting = new ProgressDialog(CommandesActivity.this);
            waiting.setTitle("Création d'une commande en cours");
            waiting.setMessage("Veuillez patienter...");
            waiting.show();
            nouvelleCommande.setEnabled(false);
        }

        @Override
        protected String doInBackground(String... params) {
            DateFormat dateFormatForNumCommande = new SimpleDateFormat("yyMMdd");
            Date date = new Date();
            try {
                HttpJsonParser httpJsonParser = new HttpJsonParser();
                Map<String, String> httpParams = new HashMap<>();
                httpParams.put("date", ""+newCommande.getDate());
                JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                        BASE_URL + "listeCommandeDate.php", "GET", httpParams);

                success = jsonObject.getInt("success");
                if (success == 1) {
                    nbrCommandesAjd = jsonObject.getInt("data");
                    nbrCommandeParDate = nbrCommandesAjd;
                    newCommande.setNum(dateFormatForNumCommande.format(date) + String.format("%03d", (nbrCommandeParDate + 1)));
                    try {
                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();
                        httpParams2.put("numero_commande", ""+dateFormatForNumCommande.format(date) + String.format("%03d", (nbrCommandeParDate + 1)));
                        httpParams2.put("nom_client", "");
                        httpParams2.put("date_commande", "" + newCommande.getDate());
                        httpParams2.put("zone", "0");
                        httpParams2.put("mode_livraison", "En retrait");
                        httpParams2.put("boutique", "" + MainActivity.code_boutique);
                        httpParams2.put("total_ht", "" + "0.00");
                        httpParams2.put("total_fdp_ht", "0.00");
                        httpParams2.put("id_operateur", ""+MainActivity.id_operateur);
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                BASE_URL + "ajouterCommande.php", "POST", httpParams2);
                        success = jsonObject2.getInt("success");
                        if (success != 1) {
                            return "Impossible d'ajouter une nouvelle commande en BO!";
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            nouvelleCommande.setEnabled(true);
            if (s == "Impossible d'ajouter une nouvelle commande en BO!") {
                afficherToast("KO", s);
            }
            if (!CommandesActivity.this.isFinishing() && waiting != null) {
                waiting.dismiss();
            }
            listeCommande.set(selectedTab - 1, newCommande);
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(currentCommande);
            mAdapterTransporteur.notifyDataSetChanged();
            recyclerView.setAdapter(mAdapter);

            messageFixe.setVisibility(View.GONE);
            messageFixe.setText("");
            afficheCommande();

            mAdapter.notifyDataSetChanged();
            recyclerViewClients.setVisibility(View.GONE);
            recyclerView.setVisibility(View.VISIBLE);
            try {
                new GetAllClientsAsyncTask().execute();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    private class VerifStockAsyncTask extends AsyncTask<String, String, String> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            listeRupture = new ArrayList<>();
            if (currentCommande != null) {
                for (Produit p : currentCommande.getListeProduit()) {
                    if ((p.getStock() - p.getQte()) <= -1) {
                        listeRupture.add(p);
                    }
                }
            } else {
                return "Impossible de vérifier les stocks produits";
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (s == null && listeRupture.size() > 0) {
                AlertDialog.Builder builder = new AlertDialog.Builder(CommandesActivity.this);
                builder.setCancelable(true);
                builder.setTitle("Rupture de stock");
                String msg = "Les articles suivants ont un stock insuffisant, veuillez mettre à jour leurs quantités.\n";
                msg += " \n";
                for (Produit p : listeRupture) {
                    if (p.getStock() > 0) {
                        msg += p.getRef() + " " + p.getColoris() + " (" + p.getStock() + " restants)\n";
                    } else {
                        msg += p.getRef() + " " + p.getColoris() + " (" + p.getStock() + " restant)\n";
                    }
                }
                builder.setMessage(msg);
                builder.setPositiveButton("OK",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        });
                builder.show();
            } else if (currentCommande != commandeAImprimer && listeRupture.size() == 0) {
                //On décrémente du stock uniquement si il y a du stock
                try {
                    //Maintenant je passe la commande courante en commande à imprimer
                    commandeAImprimer = currentCommande;
                    Collections.sort(CommandesActivity.commandeAImprimer.getListeProduit());

                    messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
                    messageFixe.setText("Impression en cours '"+dernierTypeTicket+"' vers @MAC:"+MainActivity.mac_imprimante);
                    messageFixe.setVisibility(View.VISIBLE);

                    if (dernierTypeTicket == "détaillé") {
                        if (runTicketDetaille()) {
                            messageFixe.setVisibility(View.GONE);
                            messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                            messageFixe.setText("");
                            afficherToast("OK", "Impression du ticket "+dernierTypeTicket+" effectué!");
                        } else {
                            afficherToast("KO","Impossible d'imprimer le ticket "+dernierTypeTicket+"!");
                        }
                    } else if (dernierTypeTicket == "rassemblé") {
                        new GetTicketRassembleeDonneesAsyncTask().execute();
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private void afficherToast(String typeToast, String message) {
        LayoutInflater inflater = getLayoutInflater();
        View layoutToast = inflater.inflate(R.layout.layout_custom_toast, null);
        TextView textViewToast = (TextView) layoutToast.findViewById(R.id.textViewToastMessage);
        layoutToast.setMinimumHeight(imprimer.getHeight()+50);
        layoutToast.setMinimumWidth(imprimer.getWidth());

        textViewToast.setText(message);
        if (typeToast == "KO") {
            //Jouer son notification
            jouerSon("notification.mp3");
            layoutToast.setBackgroundColor(getColor(R.color.colorRouge));
        } else if (typeToast == "OK") {
            layoutToast.setBackgroundColor(getColor(R.color.colorVert));
        } else if (typeToast == "ENCOURS") {
            layoutToast.setBackgroundColor(getColor(R.color.colorOrange));
        } else if (typeToast == "NEXISTEPAS") {
            //Jouer son notification
            jouerSon("erreurProduit.mp3");
            layoutToast.setBackgroundColor(getColor(R.color.colorRouge));
        }

        //if (typeToast != "ENCOURS") {
            Toast toast = new Toast(getApplicationContext());
            toast.setGravity(Gravity.BOTTOM, 0, 0);
            toast.setDuration(Toast.LENGTH_LONG);
            toast.setView(layoutToast);
            toast.show();
        //}
    }

    public void fermerCommandesActivity(View v){
        if (!synchronisationEnCours) {
            if (affichelistetransporteurs == 0 && affichelisteclients == 0) {
                new AlertDialog.Builder(CommandesActivity.this)
                        .setIcon(android.R.drawable.ic_dialog_alert)
                        .setTitle("Confirmation")
                        .setMessage("Etes-vous sûr de vouloir fermer les commandes?")
                        .setPositiveButton("Oui", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                scanEnPermanence = false;
                                bSoftTriggerSelected = false;
                                if (scanner != null) {
                                    scanner.triggerType = TriggerType.HARD;
                                }
                                //Fermer le clavier
                                hideKeyboard(CommandesActivity.this);

                                // The application is in background
                                // Release the barcode manager resources
                                deInitScanner();
                                deInitBarcodeManager();
                                Intent returnIntent = new Intent();
                                setResult(Activity.RESULT_OK, returnIntent);
                                finish();
                            }
                        })
                        .setNegativeButton("Non", null)
                        .show();
            } else {
                fermerLesRecherches();
            }
        }
    }

    public void fermerLesRecherches(){
        affichelisteclients = 0;
        affichelistetransporteurs = 0;
        searchBarClientCommande.setVisibility(View.GONE);
        searchBarTransporteurCommande.setVisibility(View.GONE);
        barIntituleChampsClients.setVisibility(View.GONE);
        recyclerViewClients.setVisibility(View.GONE);
        recyclerViewTransporteurs.setVisibility(View.GONE);
        infos.setVisibility(View.VISIBLE);
        imprimer.setVisibility(View.VISIBLE);
        choixCommande.setVisibility(View.VISIBLE);
        searchBar.setVisibility(View.VISIBLE);
        searchBarProduitCommande.setVisibility(View.VISIBLE);

        barNom.setVisibility(View.VISIBLE);
        barIntituleChamps.setVisibility(View.VISIBLE);
        activerToujoursScanner.setVisibility(View.VISIBLE);
        reloadScanner.setVisibility(View.VISIBLE);
        ajouterRemiseCommande.setVisibility(View.VISIBLE);
        recyclerView.setVisibility(View.VISIBLE);
    }

    private void afficherLogsScanner() {
        if (afficheLogsScanner == 1) {
            afficheLogsScanner = 0;
        } else {
            afficheLogsScanner = 1;
        }

        if (afficheLogsScanner == 1) {
            textViewStatus.setVisibility(View.VISIBLE);
        } else {
            textViewStatus.setVisibility(View.GONE);
        }
    }

    //Jouer un son en fonction d'un nom de fichier
    private void jouerSon(String filename) {
        mediaPlayer = new MediaPlayer();
        try {
            AssetFileDescriptor afd = null;
            afd = getResources().getAssets().openFd(filename);
            mediaPlayer.setDataSource(afd.getFileDescriptor(), afd.getStartOffset(), afd.getLength());
            mediaPlayer.prepareAsync();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        //Lancer en mode asynchrone pour continuer en permanence
        mediaPlayer.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
            public void onPrepared(MediaPlayer mp) {
                mp.start();
            }
        });
        //Release après lecture
        mediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
            public void onCompletion(MediaPlayer mp) {
                if (mp != null) {
                    mp.release();
                }
            }
        });
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        if (requestCode != REQUEST_PERMISSION || grantResults.length == 0) {
            return;
        }

        List<String> requestPermissions = new ArrayList<>();

        for (int i = 0; i < permissions.length; i++) {
            if (permissions[i].equals(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                    && grantResults[i] == PackageManager.PERMISSION_DENIED) {
                requestPermissions.add(permissions[i]);
            }
            if (permissions[i].equals(Manifest.permission.ACCESS_COARSE_LOCATION)
                    && grantResults[i] == PackageManager.PERMISSION_DENIED) {
                requestPermissions.add(permissions[i]);
            }
        }

        if (!requestPermissions.isEmpty()) {
            ActivityCompat.requestPermissions(this, requestPermissions.toArray(new String[requestPermissions.size()]), REQUEST_PERMISSION);
        }
    }

    /* PARTIE IMPRESSION */
    private boolean runTicketDetaille() {
        if (!initializeObject()) {
            return false;
        }

        if (!createTicketDetaille()) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }

        return true;
    }

    private boolean runTicketRassemblee(String s) {
        if (!initializeObject()) {
            return false;
        }

        if (!createTicketRassemblee(s)) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }
        return true;
    }

    //Ticket Rassemblée
    public double getPrixTotalRef(String ref) {
        double tot = 0;
        for (Produit p : CommandesActivity.commandeAImprimer.getListeProduit()) {
            if (p.getRef().equals(ref)) {
                tot += p.getPrix() * p.getQte();
            }
        }
        return tot;
    }

    private boolean createTicketDetaille() {

        StringBuilder textData = new StringBuilder();

        //Bitmap zelyx = BitmapFactory.decodeResource(getResources(), R.drawable.zelyx);

        if (mPrinter == null) {
            return false;
        }

        try {
            DecimalFormat df = new DecimalFormat("0.00");
            df.setMaximumFractionDigits(2);//arrondi à 2 chiffres après la virgule
            df.setMinimumFractionDigits(2);
            df.setDecimalSeparatorAlwaysShown(true);

            //TICKET 1
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);

            mPrinter.addFeedLine(1);

            textData.append("LISTE DE COLISAGE\n");
            textData.append("N° " + commandeAImprimer.getNum() + "\n");


            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addBarcode("{A" + commandeAImprimer.getNum(), Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");

            textData.append("CLIENT: " + CommandesActivity.commandeAImprimer.getNomClient() + "\n");

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("DATE: " + CommandesActivity.commandeAImprimer.getDate().replace("/", "-") + "\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addTextAlign(Printer.ALIGN_RIGHT);
            textData.append(MainActivity.code_boutique + " " + MainActivity.initiales_vendeur + "\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());


            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("------------------------------------------------\n");
            textData.append(String.format("%-16s", "REF") + String.format("%-5s", "COUL") + String.format("%6s", "QTE") + String.format("%8s", "PU HT  ") + String.format("%13s", "MONTANT") + "\n");

            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            for (Produit p : CommandesActivity.commandeAImprimer.getListeProduit()) {
                textData.append("------------------------------------------------\n");
                mPrinter.addTextStyle(0, 0, 1, 0);
                textData.append(String.format("%-16s", p.getRef()) + String.format("%-5s", p.getColoris()) + String.format("%6s", p.getQte()) + String.format("%8s", df.format((p.getPrix() * 100) / 100) + "  ") + String.format("%13s", df.format(p.getQte() * p.getPrix()))); //Ajout d'un caractère sur le prix pour ne pas avoir de tirrets par la suite
                mPrinter.addText(textData.toString());
                textData.delete(0, textData.length());
            }

            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);
            textData.append("------------------------------------------------\n");

            if (CommandesActivity.commandeAImprimer.getRemiseGlobalePourcentage() > 0) {
                textData.append(String.format("%-18s", "") + String.format("%30s", "AVANT REMISE: " + df.format(CommandesActivity.commandeAImprimer.getPrixTotal()) + "\n"));
                textData.append("\n");
                df.setRoundingMode(RoundingMode.HALF_UP); //ARRONDI AU SUPERIEUR
                Double remise = CommandesActivity.commandeAImprimer.getRemiseTotal();
                textData.append(String.format("%-18s", "") + String.format("%30s", "REMISE (" + df.format(CommandesActivity.commandeAImprimer.getRemiseGlobalePourcentage()) + "%) " + df.format(CommandesActivity.commandeAImprimer.getRemiseTotal()) + "\n"));
                df.setRoundingMode(RoundingMode.HALF_DOWN);
                textData.append("\n");
                textData.append(String.format("%-18s", "Qté TOTAL: " + CommandesActivity.commandeAImprimer.getQtetotal()) + String.format("%30s", "TOTAL HT: " + df.format(CommandesActivity.commandeAImprimer.getPrixTotalAvecRemise()) + "\n"));
                textData.append("\n");
            } else {
                textData.append(String.format("%-18s", "Qté TOTAL: " + CommandesActivity.commandeAImprimer.getQtetotal()) + String.format("%30s", "TOTAL HT: " + df.format(CommandesActivity.commandeAImprimer.getPrixTotal())) + "\n");
                textData.append("\n");
            }

            textData.append("TRANSPORTEUR: " + CommandesActivity.commandeAImprimer.getNomTransporteur() + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("Note: " + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());


            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());
        } catch (Exception e) {
            return false;
        }
        return true;
    }

    private boolean createTicketRassemblee(String ligneProduitsRassemblee) {

        //Imprimer le ticket
        StringBuilder textData = new StringBuilder();


        //Bitmap zelyx = BitmapFactory.decodeResource(getResources(), R.drawable.zelyx);


        if (mPrinter == null) {
        }

        try {

            //TICKET 1
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);
            mPrinter.addFeedLine(1);
            textData.append("  \n");

            textData.append("LISTE DE COLISAGE\n");
            textData.append("N°: " + commandeAImprimer.getNum() + "\n");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addBarcode("{A" + commandeAImprimer.getNum(), Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");

            textData.append("CLIENT:" + CommandesActivity.commandeAImprimer.getNomClient() + "\n");

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("DATE: " + CommandesActivity.commandeAImprimer.getDate().replace("/", "-") + "\n");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addTextAlign(Printer.ALIGN_RIGHT);
            textData.append(MainActivity.code_boutique + " " + MainActivity.initiales_vendeur + "\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("------------------------------------------------\n");

            textData.append(String.format("%-10s", "CODE ART.") + String.format("%-13s", "DES.") + String.format("%6s", "QTE") + String.format("%6s", "PU HT") + String.format("%7s", "    MONTANT") + "\n");


            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);

            mPrinter.addText(textData.toString());

            textData.delete(0, textData.length());

            //Lignes produits rassemblee depuis le JSON
            textData.append(ligneProduitsRassemblee);

            mPrinter.addText(textData.toString());

            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);

            textData.append("\n");
            textData.append("TRANSPORTEUR: " + CommandesActivity.commandeAImprimer.getNomTransporteur() + "\n");

            textData.append("\n");
            textData.append("\n");
            textData.append("Note: " + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());

            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());
        } catch (Exception e) {
        }

        return true;
    }

    private boolean printData() {
        if (mPrinter == null) {
            return false;
        }

        if (!connectPrinter()) {
            return false;
        }

        PrinterStatusInfo status = mPrinter.getStatus();

        dispPrinterWarnings(status);

        if (!isPrintable(status)) {
            logsImpression.setBackgroundColor(getColor(R.color.colorRouge));
            logsImpression.setText(makeErrorMessage(status));
            logsImpression.setVisibility(View.VISIBLE);
            try {
                mPrinter.disconnect();
            } catch (Exception ex) {
                // Do nothing
            }
            return false;
        } else {
            logsImpression.setBackgroundColor(getColor(R.color.colorOrange));
            logsImpression.setText("");
            logsImpression.setVisibility(View.GONE);
        }

        try {
            mPrinter.sendData(Printer.PARAM_DEFAULT);
        } catch (Exception e) {
            try {
                mPrinter.disconnect();
            } catch (Exception ex) {
                // Do nothing
            }
            return false;
        }

        //Une fois l'impression effectué on appel le destockage produit si la commande en cours imprimé est bien celle en cours d'édition
        if (commandeAImprimer.getNum() == currentCommande.getNum()) {
            //Passer la commande en statut A contrôler
            new UpdateAControlerCommandeAsyncTask().execute();
        }

        return true;
    }

    private boolean initializeObject() {
        try {
            mPrinter = new Printer(Printer.TM_M30, Printer.MODEL_ANK, CommandesActivity.this);
        } catch (Exception e) {
            logsImpression.setBackgroundColor(getColor(R.color.colorRouge));
            logsImpression.setText("Imprimante non initialisé!");
            logsImpression.setVisibility(View.VISIBLE);
            return false;
        }

        mPrinter.setReceiveEventListener(this);

        return true;
    }

    private void finalizeObject() {
        if (mPrinter == null) {
            return;
        }

        mPrinter.clearCommandBuffer();

        mPrinter.setReceiveEventListener(null);

        mPrinter = null;
    }

    private boolean connectPrinter() {
        boolean isBeginTransaction = false;

        if (mPrinter == null) {
            return false;
        }

        try {
            mPrinter.connect("TCP:"+MainActivity.mac_imprimante, Printer.PARAM_DEFAULT);
        } catch (Exception e) {
            logsImpression.setBackgroundColor(getColor(R.color.colorRouge));
            logsImpression.setText("Imprimante hors ligne!\n@MAC:"+MainActivity.mac_imprimante);
            logsImpression.setVisibility(View.VISIBLE);

            //NE RIEN FAIRE (Souhait d'Erik)
            //Si l'utilisateur à annulé l'impression du ticket, afficher une confirmation si
            //souhaite annulé la commande
            /*new AlertDialog.Builder(CommandesActivity.this)
                    .setIcon(android.R.drawable.ic_dialog_alert)
                    .setTitle("Confirmation")
                    .setMessage("Souhaitez-vous réellement annuler cette commande ou la valider ?")
                    .setPositiveButton("Valider", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            try {
                                //Passer la commande en statut A contrôler
                                new UpdateAControlerCommandeAsyncTask().execute();
                                dialog.dismiss();
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }

                    })
                    .setNegativeButton("Annuler", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            try {
                                NumeroDerniereCommandeAnnulee = currentCommande.getNum();
                                new UpdateAnnulerCommandeAsyncTask().execute();
                                dialog.dismiss();
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }

                    })
                    .show();*/

            return false;
        }

        try {
            mPrinter.beginTransaction();
            isBeginTransaction = true;
        } catch (Exception e) {
            e.printStackTrace();
            logsImpression.setBackgroundColor(getColor(R.color.colorRouge));
            logsImpression.setText("Impossible de débuter l'impression");
            logsImpression.setVisibility(View.VISIBLE);
        }

        if (isBeginTransaction == false) {
            try {
                mPrinter.disconnect();
            } catch (Epos2Exception e) {
                // Do nothing
                return false;
            }
        }

        return true;
    }

    private void disconnectPrinter() {
        if (mPrinter == null) {
            return;
        }

        try {
            mPrinter.endTransaction();
        } catch (final Exception e) {
            runOnUiThread(new Runnable() {
                @Override
                public synchronized void run() {
                    logsImpression.setBackgroundColor(getColor(R.color.colorRouge));
                    logsImpression.setText("Impossible de clôturer la communication!");
                    logsImpression.setVisibility(View.VISIBLE);
                }
            });
        }

        try {
            mPrinter.disconnect();
        } catch (final Exception e) {
            runOnUiThread(new Runnable() {
                @Override
                public synchronized void run() {
                    logsImpression.setBackgroundColor(getColor(R.color.colorRouge));
                    logsImpression.setText("Impossible de se déconnecter de l'imprimante");
                    logsImpression.setVisibility(View.VISIBLE);
                }
            });
        }

        finalizeObject();
    }

    private boolean isPrintable(PrinterStatusInfo status) {
        if (status == null) {
            return false;
        }

        if (status.getConnection() == Printer.FALSE) {
            return false;
        } else if (status.getOnline() == Printer.FALSE) {
            return false;
        } else {
            //print available
        }

        return true;
    }

    private String makeErrorMessage(PrinterStatusInfo status) {
        String msg = "";

        if (status.getOnline() == Printer.FALSE) {
            msg += "L'imprimante est hors ligne!"+"\n"+"";
        }
        if (status.getConnection() == Printer.FALSE) {
            msg += "Veuillez vérifier la connexion de l'imprimante au même réseau wifi qque votre terminal."+"\n"+"";
        }
        if (status.getCoverOpen() == Printer.TRUE) {
            msg += "Veuillez fermer le capot du rouleau papier."+"\n"+"";
        }
        if (status.getPaper() == Printer.PAPER_EMPTY) {
            msg += "Veuillez vérifier le rouleau papier."+"\n"+"";
        }
        if (status.getPaperFeed() == Printer.TRUE || status.getPanelSwitch() == Printer.SWITCH_ON) {
            msg += "Veuillez relacher l'interrupteur d'alimentation papier."+"\n"+"";
        }
        if (status.getErrorStatus() == Printer.MECHANICAL_ERR || status.getErrorStatus() == Printer.AUTOCUTTER_ERR) {
            msg += "Veuillez retirer le papier coincé et refermer le couvercle.\n";
            msg += "Puis, si l'imprimante n'est pas repartie, veuillez redémarrer l'imprimante.\n";
        }
        if (status.getErrorStatus() == Printer.UNRECOVER_ERR) {
            msg += "Veuillez appuyer sur l'interrupteur d'alimentation de l'imprimante.\n";
            msg += "Si les mêmes erreurs se sont produites même après le redémarrage, l'imprimante est peut être hors service.\n";
        }
        if (status.getErrorStatus() == Printer.AUTORECOVER_ERR) {
            if (status.getAutoRecoverError() == Printer.HEAD_OVERHEAT) {
                msg += "Veuillez patienter jusqu'à ce que le voyant d'erreur de l'imprimante s'éteigne.\n";
                msg += "La batterie de l'imprimante est trop chaude.\n";
            }
            if (status.getAutoRecoverError() == Printer.MOTOR_OVERHEAT) {
                msg += "Veuillez patienter jusqu'à ce que le voyant d'erreur de l'imprimante s'éteigne.\n";
                msg += "Le circuit intégré du pilote du moteur de l'imprimante est trop chaud.\n";
            }
            if (status.getAutoRecoverError() == Printer.BATTERY_OVERHEAT) {
                msg += "Veuillez patienter jusqu'à ce que le voyant d'erreur de l'imprimante s'éteigne.\n";
                msg += "La batterie de l'imprimante est trop chaude.\n";
            }
            if (status.getAutoRecoverError() == Printer.WRONG_PAPER) {
                msg += "Veuillez définir le bon rouleau de papier.\n";
            }
        }
        if (status.getBatteryLevel() == Printer.BATTERY_LEVEL_0) {
            msg += "Veuillez connecter l'adaptateur secteur ou changer la batterie.\nLa batterie de l'imprimante est presque vide.\n";
        }

        return msg;
    }

    private void dispPrinterWarnings(PrinterStatusInfo status) {

        if (status == null) {
            logsImpression.setVisibility(View.GONE);
            logsImpression.setBackgroundColor(getColor(R.color.colorOrange));
            logsImpression.setText("");
            return;
        }

        if (status.getPaper() == Printer.PAPER_NEAR_END) {
            logsImpression.setBackgroundColor(getColor(R.color.colorOrange));
            logsImpression.setText("Attention! Le rouleau papier est presque terminé!");
            logsImpression.setVisibility(View.VISIBLE);
        } else if (status.getBatteryLevel() == Printer.BATTERY_LEVEL_1) {
            logsImpression.setBackgroundColor(getColor(R.color.colorOrange));
            logsImpression.setText("Attention! Le niveau de la batterie de l'imprimante est presque vide");
            logsImpression.setVisibility(View.VISIBLE);
        }

    }

    @Override
    public void onPtrReceive(final Printer printerObj, final int code, final PrinterStatusInfo status, final String printJobId) {
        runOnUiThread(new Runnable() {
            @Override
            public synchronized void run() {

                dispPrinterWarnings(status);

                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        disconnectPrinter();
                    }
                }).start();
            }
        });
    }

    private class GetTicketRassembleeDonneesAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("num_commande", commandeAImprimer.getNum());
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeProduitsTicketRassemblee.php", "GET", httpParams);

            String ligneProduit = "";
            Double montantTotal = 0.0;
            Integer cptTotal = 0;
            String oldMarque = "";
            Double prixUnite = 0.0;
            Integer qteUnite = 0;
            try {
                int success = jsonObject.getInt("success");
                JSONArray produits;
                if (success == 1) {
                    produits = jsonObject.getJSONArray("data");
                    //Iterate through the response and populate produits list
                    DecimalFormat df = new DecimalFormat("0.00");
                    for (int i = 0; i < produits.length(); i++) { //Débute à 0 donc -1
                        //Produit p = new Produit();
                        JSONObject produit = produits.getJSONObject(i);
                        try {
                            //REQUETE SQL
                            //SELECT `zelyx_produits`.`marque`,`zelyx_produits`.`categorie`, `zelyx_produits`.`informations`, SUM(`zelyx_commandes_produits`.`quantite`) AS quantite, `zelyx_commandes_produits`.`prix` FROM `zelyx_commandes_produits`, `zelyx_produits` WHERE `zelyx_commandes_produits`.`code128_produit` AND `zelyx_produits`.`code_128` GROUP BY `zelyx_produits`.`marque`,`zelyx_produits`.`categorie`, `zelyx_commandes_produits`.`prix`

                            if (!oldMarque.equals(produit.getString("initialesMarque"))) {
                                if (produit.getString("marque").length() > 32) {
                                    ligneProduit += String.format("%-10s", produit.getString("initialesMarque")) + String.format("%-16s", produit.getString("marque").substring(0, 12)) + "\n";
                                } else {
                                    ligneProduit += String.format("%-10s", produit.getString("initialesMarque")) + String.format("%-16s", produit.getString("marque")) + "\n";
                                }
                            }
                            cptTotal += produit.getInt("quantite_produit_marque");
                            oldMarque = produit.getString("initialesMarque");

                            prixUnite = Double.parseDouble(produit.getString("prix"));
                            qteUnite = Integer.parseInt(produit.getString("quantite"));

                            //textData.append(String.format("%-18s", "CODE ART.") + String.format("%-5s", "DES.") + String.format("%-6s", "QTE") + String.format("%-6s", "PU HT") + String.format("%-12s", "MONTANT") + "\n");
                            ligneProduit += String.format("%-10s", produit.getString("code_ebp"));

                            if (produit.getString("informations").length() > 12) {
                                ligneProduit += String.format("%-13s", produit.getString("informations").substring(0,12)).replaceAll("\\s(?=\\s+$|$)", ".");
                                //ligneProduit += String.format("%-13s", produit.getString("informations").substring(0,12));
                            } else {
                                ligneProduit += String.format("%-13s", produit.getString("informations"));
                            }

                            ligneProduit += String.format("%6s", produit.getString("quantite"));
                            ligneProduit += String.format("%6s", df.format(prixUnite));


                            ligneProduit += String.format("%12s", df.format(prixUnite * qteUnite));
                            ligneProduit += "\n";

                            montantTotal += prixUnite * qteUnite;
                            //cptTotal += qteUnite; //RECUPERE SUR LA LIGNE MARQUE RASSEMBLE

                        } catch (Exception e) {
                            e.printStackTrace();
                            return "Erreur création ticket: " + e;
                        }
                        ligneProduitsRassemblee += ligneProduit;
                        ligneProduitsRassembleeTotal = montantTotal;
                        ligneProduitsRassembleeTotalQte = cptTotal;
                    }
                    ligneProduit += "------------------------------------------------\n";
                    //ligneProduit += String.format("%-18s", "Total pièces: " + ligneProduitsRassembleeTotalQte) + String.format("%30s", "Total HT: " + df.format(ligneProduitsRassembleeTotal)) + "\n";

                    HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                    Map<String, String> httpParams2 = new HashMap<>();
                    httpParams2.put("num_commande", commandeAImprimer.getNum());
                    JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                            BASE_URL + "getRemiseListeProduitsTicketRassemblee.php", "GET", httpParams2);

                    Double remiseGlobale;
                    remiseGlobale = 0.0;
                    int success2 = jsonObject.getInt("success");
                    JSONArray produits2;
                    if (success2 == 1) {
                        produits2 = jsonObject2.getJSONArray("data");
                        //Iterate through the response and populate produits list
                        for (int i = 0; i < produits2.length(); i++) {
                            JSONObject produit2 = produits2.getJSONObject(i);
                            if (produit2.getString("remiseGlobale") != null) {
                                remiseGlobale = produit2.getDouble("remiseGlobale");
                            }
                        }
                    }

                    if (CommandesActivity.commandeAImprimer.getRemiseGlobalePourcentage() > 0) {
                        ligneProduit += (String.format("%-18s", "") + String.format("%30s", "AVANT REMISE: " + df.format(montantTotal) + "\n"));
                        ligneProduit += ("\n");
                        df.setRoundingMode(RoundingMode.HALF_UP); //ARRONDI AU SUPERIEUR
                        Double remise = ((montantTotal*remiseGlobale)/100);
                        ligneProduit += (String.format("%-18s", "") + String.format("%30s", "REMISE ("+df.format(remiseGlobale)+"%) " + df.format(remise) + "\n"));
                        df.setRoundingMode(RoundingMode.HALF_DOWN);
                        ligneProduit += ("\n");
                        ligneProduit += (String.format("%-18s", "Qté TOTAL: " + cptTotal) + String.format("%30s", "TOTAL HT: " + df.format(montantTotal-remise) + "\n"));
                        ligneProduit += ("\n");
                    } else {
                        ligneProduit += (String.format("%-18s", "Qté TOTAL: " + cptTotal) + String.format("%30s", "TOTAL HT: " + df.format(montantTotal)) + "\n");
                        ligneProduit += ("\n");
                    }

                    return ligneProduit;
                    //Lancement de l'impression après

                } else {
                    ligneProduit = "aucun";
                    return ligneProduit;
                }
            } catch (JSONException e) {
                return "" + e;
            } catch (Exception e) {
                return "" + e;
            }

        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            //Lancement de l'impression rassemblée
            if (!runTicketRassemblee(s)) {
                logsImpression.setBackgroundColor(getColor(R.color.colorRouge));
                logsImpression.setText("Imprimante hors ligne!\n@MAC:"+MainActivity.mac_imprimante);
                logsImpression.setVisibility(View.VISIBLE);
                afficherToast("KO","Impossible d'imprimer le ticket "+dernierTypeTicket+"!");
            } else {
                messageFixe.setVisibility(View.GONE);
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("");
                afficherToast("OK", "Impression du ticket "+dernierTypeTicket+" effectué!");
            }
        }
    }

    public void imprimerDeNouveau(View v) {
        nbTentativesImpression++;
        logsImpression.setText("Tentative "+nbTentativesImpression);
        logsImpression.setVisibility(View.VISIBLE);
        if (dernierTypeTicket.equals("détaillé")) {
            runTicketDetaille();
        } else if (dernierTypeTicket.equals("rassemblé")) {
            new GetTicketRassembleeDonneesAsyncTask().execute();
        }
    }

    public static void hideKeyboard(Activity activity) {
        View view = activity.findViewById(android.R.id.content);
        if (view != null) {
            InputMethodManager imm = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(view.getWindowToken(), 0);
        }
    }

    public static void showKeyboard(Activity activity) {
        InputMethodManager inputMethodManager = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
        inputMethodManager.toggleSoftInput(InputMethodManager.SHOW_FORCED, 0);
    }

}