package fr.itsee.zelyx;

import android.Manifest;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Build;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;

import java.util.ArrayList;
import java.util.List;

public class MainActivity extends AppCompatActivity {

    //a la racine
    public static String backOfficeURLIMG = "https://zelyx.com/";

    //lien vers inc
    public static String backOfficeURL = backOfficeURLIMG+"inc/";

    LinearLayout main;

    //Identification
    public static String code_vendeur = "0";
    public static String code_boutique = "";
    public static String initiales_vendeur = "";
    public static String mac_imprimante = "";
    public static String id_operateur = "0";

    //Permissions
    private static final int REQUEST_PERMISSION = 100;

    //Bouttons
    private Button btnCommandes, btnControles, btnPermissions;
    private int permissionAccessNetworkState, permissionAccessWifiState, permissionCamera;

    @Override
    public void onBackPressed() {
        new AlertDialog.Builder(MainActivity.this)
                .setIcon(android.R.drawable.ic_dialog_alert)
                .setTitle("Confirmation")
                .setMessage("Etes-vous sûr de vouloir vous déconnecter?")
                .setPositiveButton("Oui", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        initiales_vendeur = null;
                        code_vendeur = "0";
                        code_boutique = "";
                        initiales_vendeur = "";
                        mac_imprimante = "";
                        id_operateur = "0";
                        Intent intent = new Intent(getApplicationContext(), IdentificationActivity.class);
                        startActivity(intent);
                        overridePendingTransition(0, 0);
                        finish();
                    }
                })
                .setNegativeButton("Non", null)
                .show();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        main = findViewById(R.id.main);

        permissionAccessNetworkState = ContextCompat.checkSelfPermission(this, Manifest.permission.ACCESS_NETWORK_STATE);
        permissionAccessWifiState = ContextCompat.checkSelfPermission(this, Manifest.permission.ACCESS_WIFI_STATE);
        permissionCamera = ContextCompat.checkSelfPermission(this, Manifest.permission.CAMERA);

        btnCommandes = findViewById(R.id.btnCommandes);
        btnControles = findViewById(R.id.btnControles);
        btnPermissions = findViewById(R.id.btnPermissions);

        if (permissionAccessNetworkState == PackageManager.PERMISSION_DENIED || permissionAccessWifiState == PackageManager.PERMISSION_DENIED || permissionCamera == PackageManager.PERMISSION_DENIED) {
            btnCommandes.setVisibility(View.GONE);
            btnControles.setVisibility(View.GONE);
            btnPermissions.setVisibility(View.VISIBLE);
        } else {
            btnPermissions.setVisibility(View.GONE);
            btnCommandes.setVisibility(View.VISIBLE);
            btnControles.setVisibility(View.VISIBLE);
        }

        btnCommandes.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (isOnline()) {
                    Intent intent = new Intent(getApplicationContext(), CommandesActivity.class);
                    startActivityForResult(intent, 100);
                    overridePendingTransition(0, 0);
                } else {
                    Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
                    startActivityForResult(intent, 1);
                    overridePendingTransition(0, 0);
                }
            }
        });

        btnControles.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {

                if (isOnline()) {
                    Intent intent = new Intent(getApplicationContext(), ControleActivity.class);
                    startActivityForResult(intent, 200);
                    overridePendingTransition(0, 0);
                } else {
                    Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
                    startActivityForResult(intent, 1);
                    overridePendingTransition(0, 0);
                }
            }
        });

        btnPermissions.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                requestRuntimePermission();
                MainActivity.this.recreate();
            }
        });

    }

    private void requestRuntimePermission() {
        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
            return;
        }
        List<String> requestPermissions = new ArrayList<>();
        if (permissionAccessNetworkState == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.ACCESS_NETWORK_STATE);
        }
        if (permissionAccessWifiState == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.ACCESS_WIFI_STATE);
        }
        if (permissionCamera == PackageManager.PERMISSION_DENIED) {
            requestPermissions.add(Manifest.permission.CAMERA);
        }
        if (!requestPermissions.isEmpty()) {
            ActivityCompat.requestPermissions(this, requestPermissions.toArray(new String[requestPermissions.size()]), REQUEST_PERMISSION);
        }

        if (permissionAccessNetworkState == PackageManager.PERMISSION_DENIED || permissionAccessWifiState == PackageManager.PERMISSION_DENIED || permissionCamera == PackageManager.PERMISSION_DENIED) {
            btnCommandes.setVisibility(View.GONE);
            btnControles.setVisibility(View.GONE);
            btnPermissions.setVisibility(View.VISIBLE);
        } else {
            btnPermissions.setVisibility(View.GONE);
            btnCommandes.setVisibility(View.VISIBLE);
            btnControles.setVisibility(View.VISIBLE);
        }

    }

    protected boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        return netInfo != null && netInfo.isConnectedOrConnecting();
    }

    @Override
    protected void onPause() {
        super.onPause();
        this.overridePendingTransition(0, 0);
    }

    @Override
    protected void onRestart() {
        super.onRestart();
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    public void deconnexion(View v){
        new AlertDialog.Builder(MainActivity.this)
                .setIcon(android.R.drawable.ic_dialog_alert)
                .setTitle("Confirmation")
                .setMessage("Etes-vous sûr de vouloir vous déconnecter?")
                .setPositiveButton("Oui", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        initiales_vendeur = null;
                        code_vendeur = "0";
                        code_boutique = "";
                        initiales_vendeur = "";
                        mac_imprimante = "";
                        id_operateur = "0";
                        Intent intent = new Intent(getApplicationContext(), IdentificationActivity.class);
                        startActivity(intent);
                        overridePendingTransition(0, 0);
                        finish();
                    }
                })
                .setNegativeButton("Non", null)
                .show();
    }

}
