package fr.itsee.zelyx;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.content.res.AssetFileDescriptor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.MediaPlayer;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;
import com.epson.epos2.Epos2CallbackCode;
import com.epson.epos2.Epos2Exception;
import com.epson.epos2.Log;
import com.epson.epos2.printer.Printer;
import com.epson.epos2.printer.PrinterStatusInfo;
import com.epson.epos2.printer.ReceiveListener;
import com.google.gson.Gson;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.epson.epos2.Epos2CallbackCode;
import com.epson.epos2.Epos2Exception;

public class TicketActivity extends Activity implements ReceiveListener {
    public String ligneProduitsRassemblee = "";
    public Double ligneProduitsRassembleeTotal = 0.0;
    public Integer ligneProduitsRassembleeTotalQte = 0;
    private String numero_commande;
    private String typeticket;
    private Printer mPrinter = null;
    private TextView impressionEnCoursTxt;
    public TextView messageFixe, nbTentativesTxt;

    @Override
    public void onBackPressed() {
        Intent returnIntent = new Intent();
        setResult(Activity.RESULT_CANCELED, returnIntent);
        finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_ticket);
        this.setFinishOnTouchOutside(false);

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

        messageFixe = findViewById(R.id.messageFixe);

        messageFixe.setVisibility(View.GONE);

        nbTentativesTxt = findViewById(R.id.nbTentativesTxt);

        impressionEnCoursTxt = findViewById(R.id.impressionEnCours);

        if (CommandesActivity.commandeAImprimer.getNum() == null || CommandesActivity.commandeAImprimer.getNum().isEmpty()) {
            impressionEnCoursTxt.setText("Cette commande n'existe pas !");
        } else {
            impressionEnCoursTxt.setText("Ré-Impression en cours..." + "\n" + "Cmd n°" + CommandesActivity.commandeAImprimer.getNum());
        }

        if (CommandesActivity.commandeAImprimer.getNum() == null || CommandesActivity.commandeAImprimer.getNum().isEmpty()) {
            //Récupération de la commande
            typeticket = CommandesActivity.dernierTypeTicket;

            numero_commande = CommandesActivity.commandeAImprimer.getNum();

            Collections.sort(CommandesActivity.commandeAImprimer.getListeProduit());

            //Si Ticket "détaillé"
            if (typeticket.equals("détaillé")) {
                //new GetTicketDetailleeDonneesAsyncTask().execute();
                if (runTicketDetaille()) {
                    //Ticket Détaillé imprimé
                    Intent returnIntent = new Intent();
                    setResult(Activity.RESULT_OK, returnIntent);
                    finish();
                }
            } else if (typeticket.equals("rassemblé")) {
                new GetTicketRassembleeDonneesAsyncTask().execute();
            }
            //Affiche le bouton Fermer/Annuler après 10 secondes
            Handler handler = new Handler();
            handler.postDelayed(new Runnable() {
                @Override
                public void run() {
                    Intent returnIntent = new Intent();
                    setResult(Activity.RESULT_CANCELED, returnIntent);
                    finish();
                }
            }, 10000);
        } else {
            messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
            messageFixe.setText("Cette commande"+"\n"+"n'existe pas!");
            messageFixe.setVisibility(View.VISIBLE);

            Intent returnIntent = new Intent();
            setResult(Activity.RESULT_CANCELED, returnIntent);
            finish();
        }
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

    }

    private boolean runTicketDetaille() {
        if (!initializeObject()) {
            return false;
        }

        if (!createTicketDetaille()) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }
        return true;
    }

    private boolean runTicketRassemblee(String s) {
        if (!initializeObject()) {
            return false;
        }

        if (!createTicketRassemblee(s)) {
            finalizeObject();
            return false;
        }

        if (!printData()) {
            finalizeObject();
            return false;
        }
        return true;
    }

    //Ticket Rassemblée
    public double getPrixTotalRef(String ref) {
        double tot = 0;
        for (Produit p : CommandesActivity.commandeAImprimer.getListeProduit()) {
            if (p.getRef().equals(ref)) {
                tot += p.getPrix() * p.getQte();
            }
        }
        return tot;
    }

    private boolean createTicketDetaille() {

        StringBuilder textData = new StringBuilder();

        //Bitmap zelyx = BitmapFactory.decodeResource(getResources(), R.drawable.zelyx);

        if (mPrinter == null) {
            return false;
        }

        try {
            DecimalFormat df = new DecimalFormat("0.00");
            df.setMaximumFractionDigits(2);//arrondi à 2 chiffres après la virgule
            df.setMinimumFractionDigits(2);
            df.setDecimalSeparatorAlwaysShown(true);

            //TICKET 1
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);

            mPrinter.addFeedLine(1);

            textData.append("LISTE DE COLISAGE\n");
            textData.append("N° " + numero_commande + "\n");


            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addBarcode("{A" + numero_commande, Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");

            textData.append("CLIENT: " + CommandesActivity.commandeAImprimer.getNomClient() + "\n");

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("DATE: " + CommandesActivity.commandeAImprimer.getDate().replace("/", "-") + "\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addTextAlign(Printer.ALIGN_RIGHT);
            textData.append(MainActivity.code_boutique + " " + MainActivity.initiales_vendeur + "\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());


            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("------------------------------------------------\n");
            textData.append(String.format("%-16s", "REF") + String.format("%-5s", "COUL") + String.format("%6s", "QTE") + String.format("%8s", "PU HT  ") + String.format("%13s", "MONTANT") + "\n");

            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            for (Produit p : CommandesActivity.commandeAImprimer.getListeProduit()) {
                textData.append("------------------------------------------------\n");
                mPrinter.addTextStyle(0, 0, 1, 0);
                textData.append(String.format("%-16s", p.getRef()) + String.format("%-5s", p.getColoris()) + String.format("%6s", p.getQte()) + String.format("%8s", df.format((p.getPrix() * 100) / 100) + "  ") + String.format("%13s", df.format(p.getQte() * p.getPrix()))); //Ajout d'un caractère sur le prix pour ne pas avoir de tirrets par la suite
                mPrinter.addText(textData.toString());
                textData.delete(0, textData.length());
            }

            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);
            textData.append("------------------------------------------------\n");

            if (CommandesActivity.commandeAImprimer.getRemiseGlobalePourcentage() > 0) {
                textData.append(String.format("%-18s", "") + String.format("%30s", "AVANT REMISE: " + df.format(CommandesActivity.commandeAImprimer.getPrixTotal()) + "\n"));
                textData.append("\n");
                df.setRoundingMode(RoundingMode.HALF_UP); //ARRONDI AU SUPERIEUR
                Double remise = CommandesActivity.commandeAImprimer.getRemiseTotal();
                textData.append(String.format("%-18s", "") + String.format("%30s", "REMISE (" + df.format(CommandesActivity.commandeAImprimer.getRemiseGlobalePourcentage()) + "%) " + df.format(CommandesActivity.commandeAImprimer.getRemiseTotal()) + "\n"));
                df.setRoundingMode(RoundingMode.HALF_DOWN);
                textData.append("\n");
                textData.append(String.format("%-18s", "Qté TOTAL: " + CommandesActivity.commandeAImprimer.getQtetotal()) + String.format("%30s", "TOTAL HT: " + df.format(CommandesActivity.commandeAImprimer.getPrixTotalAvecRemise()) + "\n"));
                textData.append("\n");
            } else {
                textData.append(String.format("%-18s", "Qté TOTAL: " + CommandesActivity.commandeAImprimer.getQtetotal()) + String.format("%30s", "TOTAL HT: " + df.format(CommandesActivity.commandeAImprimer.getPrixTotal())) + "\n");
                textData.append("\n");
            }

            textData.append("TRANSPORTEUR: " + CommandesActivity.commandeAImprimer.getNomTransporteur() + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("Note: " + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());


            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());
        } catch (Exception e) {
            return false;
        }
        return true;
    }

    private boolean createTicketRassemblee(String ligneProduitsRassemblee) {

        //Imprimer le ticket
        StringBuilder textData = new StringBuilder();


        //Bitmap zelyx = BitmapFactory.decodeResource(getResources(), R.drawable.zelyx);


        if (mPrinter == null) {
        }

        try {

            //TICKET 1
            mPrinter.addTextAlign(Printer.ALIGN_CENTER);

            mPrinter.addTextSize(1, 1);
            mPrinter.addFeedLine(1);
            textData.append("  \n");

            textData.append("LISTE DE COLISAGE\n");
            textData.append("N°: " + numero_commande + "\n");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addBarcode("{A" + numero_commande, Printer.BARCODE_CODE128, Printer.PARAM_DEFAULT, Printer.PARAM_DEFAULT, 2, 64);

            textData.append("\n");

            textData.append("CLIENT:" + CommandesActivity.commandeAImprimer.getNomClient() + "\n");

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("DATE: " + CommandesActivity.commandeAImprimer.getDate().replace("/", "-") + "\n");

            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addTextAlign(Printer.ALIGN_RIGHT);
            textData.append(MainActivity.code_boutique + " " + MainActivity.initiales_vendeur + "\n");
            mPrinter.addText(textData.toString());
            textData.delete(0, textData.length());

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);
            textData.append("------------------------------------------------\n");

            textData.append(String.format("%-10s", "CODE ART.") + String.format("%-13s", "DES.") + String.format("%6s", "QTE") + String.format("%6s", "PU HT") + String.format("%7s", "    MONTANT") + "\n");


            //12 10 10 15 = 47
            //12 10 8 8 9 = 47

            mPrinter.addTextAlign(Printer.ALIGN_LEFT);

            mPrinter.addText(textData.toString());

            textData.delete(0, textData.length());

            //Lignes produits rassemblee depuis le JSON
            textData.append(ligneProduitsRassemblee);

            mPrinter.addText(textData.toString());

            textData.delete(0, textData.length());
            mPrinter.addTextStyle(0, 0, 0, 0);

            textData.append("\n");
            textData.append("TRANSPORTEUR: " + CommandesActivity.commandeAImprimer.getNomTransporteur() + "\n");

            textData.append("\n");
            textData.append("\n");
            textData.append("Note: " + "\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            textData.append("\n");
            mPrinter.addText(textData.toString());

            mPrinter.addCut(Printer.CUT_FEED);
            textData.delete(0, textData.length());
        } catch (Exception e) {
        }

        return true;
    }

    public int getQteRef(String ref) {
        int res = 0;
        for (Produit p : CommandesActivity.commandeAImprimer.getListeProduit()) {
            if (p.getRef().equals(ref)) {
                res += p.getQte();
            }
        }
        return res;
    }

    private boolean printData() {
        if (mPrinter == null) {
            return false;
        }

        if (!connectPrinter()) {
            return false;
        }

        PrinterStatusInfo status = mPrinter.getStatus();

        dispPrinterWarnings(status);

        if (!isPrintable(status)) {
            messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
            messageFixe.setText(makeErrorMessage(status));
            messageFixe.setVisibility(View.VISIBLE);
            messageFixe.setVisibility(View.GONE);
            try {
                mPrinter.disconnect();
            } catch (Exception ex) {
                // Do nothing
            }
            return false;
        } else {
            messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
            messageFixe.setText("");
            messageFixe.setVisibility(View.GONE);
        }

        try {
            mPrinter.sendData(Printer.PARAM_DEFAULT);
        } catch (Exception e) {
            try {
                mPrinter.disconnect();
            } catch (Exception ex) {
                // Do nothing
            }
            return false;
        }

        return true;
    }

    private boolean initializeObject() {
        try {
            mPrinter = new Printer(Printer.TM_M30, Printer.MODEL_ANK,
                    TicketActivity.this);
        } catch (Exception e) {
            messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
            messageFixe.setText("Imprimante hors ligne!\n@MAC:"+MainActivity.mac_imprimante);
            messageFixe.setVisibility(View.VISIBLE);
            return false;
        }

        mPrinter.setReceiveEventListener(this);

        return true;
    }

    private void finalizeObject() {
        if (mPrinter == null) {
            return;
        }

        mPrinter.clearCommandBuffer();

        mPrinter.setReceiveEventListener(null);

        mPrinter = null;
    }

    private boolean connectPrinter() {
        boolean isBeginTransaction = false;

        if (mPrinter == null) {
            return false;
        }

        try {
            mPrinter.connect("TCP:"+MainActivity.mac_imprimante, Printer.PARAM_DEFAULT);
        } catch (Exception e) {
            messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
            messageFixe.setText("Imprimante hors ligne!\n@MAC:"+MainActivity.mac_imprimante);
            messageFixe.setVisibility(View.VISIBLE);
            return false;
        }

        try {
            mPrinter.beginTransaction();
            isBeginTransaction = true;
        } catch (Exception e) {
            messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
            messageFixe.setText("Impossible de débuter l'impression");
            messageFixe.setVisibility(View.VISIBLE);
        }

        if (isBeginTransaction == false) {
            try {
                mPrinter.disconnect();
            } catch (Epos2Exception e) {
                // Do nothing
                return false;
            }
        }

        return true;
    }

    private void disconnectPrinter() {
        if (mPrinter == null) {
            return;
        }

        try {
            mPrinter.endTransaction();
        } catch (final Exception e) {
            runOnUiThread(new Runnable() {
                @Override
                public synchronized void run() {
                    messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                    messageFixe.setText("Impossible de clôturer la communication!");
                    messageFixe.setVisibility(View.VISIBLE);
                }
            });
        }

        try {
            mPrinter.disconnect();
        } catch (final Exception e) {
            runOnUiThread(new Runnable() {
                @Override
                public synchronized void run() {
                    messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                    messageFixe.setText("Impossible de se déconnecter de l'imprimante");
                    messageFixe.setVisibility(View.VISIBLE);
                }
            });
        }

        finalizeObject();
    }

    private boolean isPrintable(PrinterStatusInfo status) {
        if (status == null) {
            return false;
        }

        if (status.getConnection() == Printer.FALSE) {
            return false;
        } else if (status.getOnline() == Printer.FALSE) {
            return false;
        } else {
            //print available
        }

        return true;
    }
    private String makeErrorMessage(PrinterStatusInfo status) {
        String msg = "";

        if (status.getOnline() == Printer.FALSE) {
            msg += "L'imprimante est hors ligne!"+"\n"+"";
        }
        if (status.getConnection() == Printer.FALSE) {
            msg += "Veuillez vérifier la connexion de l'imprimante au même réseau wifi qque votre terminal."+"\n"+"";
        }
        if (status.getCoverOpen() == Printer.TRUE) {
            msg += "Veuillez fermer le capot du rouleau papier."+"\n"+"";
        }
        if (status.getPaper() == Printer.PAPER_EMPTY) {
            msg += "Veuillez vérifier le rouleau papier."+"\n"+"";
        }
        if (status.getPaperFeed() == Printer.TRUE || status.getPanelSwitch() == Printer.SWITCH_ON) {
            msg += "Veuillez relacher l'interrupteur d'alimentation papier."+"\n"+"";
        }
        if (status.getErrorStatus() == Printer.MECHANICAL_ERR || status.getErrorStatus() == Printer.AUTOCUTTER_ERR) {
            msg += "Veuillez retirer le papier coincé et refermer le couvercle.\n";
            msg += "Puis, si l'imprimante n'est pas repartie, veuillez redémarrer l'imprimante.\n";
        }
        if (status.getErrorStatus() == Printer.UNRECOVER_ERR) {
            msg += "Veuillez appuyer sur l'interrupteur d'alimentation de l'imprimante.\n";
            msg += "Si les mêmes erreurs se sont produites même après le redémarrage, l'imprimante est peut être hors service.\n";
        }
        if (status.getErrorStatus() == Printer.AUTORECOVER_ERR) {
            if (status.getAutoRecoverError() == Printer.HEAD_OVERHEAT) {
                msg += "Veuillez patienter jusqu'à ce que le voyant d'erreur de l'imprimante s'éteigne.\n";
                msg += "La batterie de l'imprimante est trop chaude.\n";
            }
            if (status.getAutoRecoverError() == Printer.MOTOR_OVERHEAT) {
                msg += "Veuillez patienter jusqu'à ce que le voyant d'erreur de l'imprimante s'éteigne.\n";
                msg += "Le circuit intégré du pilote du moteur de l'imprimante est trop chaud.\n";
            }
            if (status.getAutoRecoverError() == Printer.BATTERY_OVERHEAT) {
                msg += "Veuillez patienter jusqu'à ce que le voyant d'erreur de l'imprimante s'éteigne.\n";
                msg += "La batterie de l'imprimante est trop chaude.\n";
            }
            if (status.getAutoRecoverError() == Printer.WRONG_PAPER) {
                msg += "Veuillez définir le bon rouleau de papier.\n";
            }
        }
        if (status.getBatteryLevel() == Printer.BATTERY_LEVEL_0) {
            msg += "Veuillez connecter l'adaptateur secteur ou changer la batterie.\nLa batterie de l'imprimante est presque vide.\n";
        }

        return msg;
    }

    private void dispPrinterWarnings(PrinterStatusInfo status) {

        if (status == null) {
            messageFixe.setVisibility(View.GONE);
            messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
            messageFixe.setText("");
            return;
        }

        if (status.getPaper() == Printer.PAPER_NEAR_END) {
            messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
            messageFixe.setText("Attention! Le rouleau papier est presque terminé!");
            messageFixe.setVisibility(View.VISIBLE);
        } else if (status.getBatteryLevel() == Printer.BATTERY_LEVEL_1) {
            messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
            messageFixe.setText("Attention! Le niveau de la batterie de l'imprimante est presque vide");
            messageFixe.setVisibility(View.VISIBLE);
        }

    }

    @Override
    public void onPtrReceive(final Printer printerObj, final int code, final PrinterStatusInfo status, final String printJobId) {
        runOnUiThread(new Runnable() {
            @Override
            public synchronized void run() {

                dispPrinterWarnings(status);

                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        disconnectPrinter();
                    }
                }).start();
            }
        });
    }

    private class GetTicketRassembleeDonneesAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("num_commande", numero_commande);
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeProduitsTicketRassemblee.php", "GET", httpParams);
            //List<Produit> produitList = new ArrayList<>();
            String ligneProduit = "";
            Double montantTotal = 0.0;
            Integer cptTotal = 0;
            String oldMarque = "";
            Double prixUnite = 0.0;
            Integer qteUnite = 0;
            try {
                int success = jsonObject.getInt("success");
                JSONArray produits;
                if (success == 1) {
                    produits = jsonObject.getJSONArray("data");
                    //Iterate through the response and populate produits list
                    DecimalFormat df = new DecimalFormat("0.00");
                    for (int i = 0; i < produits.length(); i++) { //Débute à 0 donc -1
                        //Produit p = new Produit();
                        JSONObject produit = produits.getJSONObject(i);
                        try {
                            //REQUETE SQL
                            //SELECT `zelyx_produits`.`marque`,`zelyx_produits`.`categorie`, `zelyx_produits`.`informations`, SUM(`zelyx_commandes_produits`.`quantite`) AS quantite, `zelyx_commandes_produits`.`prix` FROM `zelyx_commandes_produits`, `zelyx_produits` WHERE `zelyx_commandes_produits`.`code128_produit` AND `zelyx_produits`.`code_128` GROUP BY `zelyx_produits`.`marque`,`zelyx_produits`.`categorie`, `zelyx_commandes_produits`.`prix`

                            if (!oldMarque.equals(produit.getString("initialesMarque"))) {
                                if (produit.getString("marque").length() > 32) {
                                    ligneProduit += String.format("%-10s", produit.getString("initialesMarque")) + String.format("%-16s", produit.getString("marque").substring(0, 12)) + "\n";
                                } else {
                                    ligneProduit += String.format("%-10s", produit.getString("initialesMarque")) + String.format("%-16s", produit.getString("marque")) + "\n";
                                }
                            }
                            cptTotal += produit.getInt("quantite_produit_marque");
                            oldMarque = produit.getString("initialesMarque");

                            prixUnite = Double.parseDouble(produit.getString("prix"));
                            qteUnite = Integer.parseInt(produit.getString("quantite"));

                            //textData.append(String.format("%-18s", "CODE ART.") + String.format("%-5s", "DES.") + String.format("%-6s", "QTE") + String.format("%-6s", "PU HT") + String.format("%-12s", "MONTANT") + "\n");
                            ligneProduit += String.format("%-10s", produit.getString("code_ebp"));

                            if (produit.getString("informations").length() > 12) {
                                ligneProduit += String.format("%-13s", produit.getString("informations").substring(0,12)).replaceAll("\\s(?=\\s+$|$)", ".");
                                //ligneProduit += String.format("%-13s", produit.getString("informations").substring(0,12));
                            } else {
                                ligneProduit += String.format("%-13s", produit.getString("informations"));
                            }

                            ligneProduit += String.format("%6s", produit.getString("quantite"));
                            ligneProduit += String.format("%6s", df.format(prixUnite));


                            ligneProduit += String.format("%12s", df.format(prixUnite * qteUnite));
                            ligneProduit += "\n";

                            montantTotal += prixUnite * qteUnite;
                            //cptTotal += qteUnite; //RECUPERE SUR LA LIGNE MARQUE RASSEMBLE

                        } catch (Exception e) {
                            e.printStackTrace();
                            return "Erreur création ticket: " + e;
                        }
                        ligneProduitsRassemblee += ligneProduit;
                        ligneProduitsRassembleeTotal = montantTotal;
                        ligneProduitsRassembleeTotalQte = cptTotal;
                    }
                    ligneProduit += "------------------------------------------------\n";
                    //ligneProduit += String.format("%-18s", "Total pièces: " + ligneProduitsRassembleeTotalQte) + String.format("%30s", "Total HT: " + df.format(ligneProduitsRassembleeTotal)) + "\n";

                    HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                    Map<String, String> httpParams2 = new HashMap<>();
                    httpParams2.put("num_commande", numero_commande);
                    JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                            BASE_URL + "getRemiseListeProduitsTicketRassemblee.php", "GET", httpParams2);

                    Double remiseGlobale;
                    remiseGlobale = 0.0;
                    int success2 = jsonObject.getInt("success");
                    JSONArray produits2;
                    if (success2 == 1) {
                        produits2 = jsonObject2.getJSONArray("data");
                        //Iterate through the response and populate produits list
                        for (int i = 0; i < produits2.length(); i++) {
                            JSONObject produit2 = produits2.getJSONObject(i);
                            if (produit2.getString("remiseGlobale") != null) {
                                remiseGlobale = produit2.getDouble("remiseGlobale");
                            }
                        }
                    }

                    if (CommandesActivity.commandeAImprimer.getRemiseGlobalePourcentage() > 0) {
                        ligneProduit += (String.format("%-18s", "") + String.format("%30s", "AVANT REMISE: " + df.format(montantTotal) + "\n"));
                        ligneProduit += ("\n");
                        df.setRoundingMode(RoundingMode.HALF_UP); //ARRONDI AU SUPERIEUR
                        Double remise = ((montantTotal*remiseGlobale)/100);
                        ligneProduit += (String.format("%-18s", "") + String.format("%30s", "REMISE ("+df.format(remiseGlobale)+"%) " + df.format(remise) + "\n"));
                        df.setRoundingMode(RoundingMode.HALF_DOWN);
                        ligneProduit += ("\n");
                        ligneProduit += (String.format("%-18s", "Qté TOTAL: " + cptTotal) + String.format("%30s", "TOTAL HT: " + df.format(montantTotal-remise) + "\n"));
                        ligneProduit += ("\n");
                    } else {
                        ligneProduit += (String.format("%-18s", "Qté TOTAL: " + cptTotal) + String.format("%30s", "TOTAL HT: " + df.format(montantTotal)) + "\n");
                        ligneProduit += ("\n");
                    }

                    return ligneProduit;
                    //Lancement de l'impression après

                } else {
                    ligneProduit = "aucun";
                    return ligneProduit;
                }
            } catch (JSONException e) {
                e.printStackTrace();
                return "" + e;
            } catch (Exception e) {
                e.printStackTrace();
                return "" + e;
            }

        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            //Lancement de l'impression rassemblée
            Intent returnIntent = new Intent();
            if (runTicketRassemblee(s)) {
                //Ticket Rassemblé imprimé
                setResult(Activity.RESULT_OK, returnIntent);
            } else {
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("Imprimante hors ligne!\n@MAC:"+MainActivity.mac_imprimante);
                messageFixe.setVisibility(View.VISIBLE);
                setResult(Activity.RESULT_CANCELED, returnIntent);
            }
            //Fermeture de la fenêtre ticket ré-imp
            finish();
        }
    }

}
