package fr.itsee.zelyx;

import static java.lang.Double.parseDouble;
import static java.lang.Double.valueOf;
import static java.lang.Integer.parseInt;

import android.content.Context;
import android.graphics.Typeface;
import android.os.AsyncTask;
import android.os.Build;
import android.os.StrictMode;
import android.support.v7.widget.RecyclerView;
import android.text.Html;
import android.text.Spanned;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.Filter;
import android.widget.Filterable;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TransporteurAdapter extends RecyclerView.Adapter<TransporteurAdapter.MyViewHolder> implements Filterable {
//    public class TransporteurAdapter extends RecyclerView.Adapter<fr.itsee.zelyx.TransporteurAdapter.MyViewHolder> {

    public static List<Transporteur> listeAllTransporteurs;
    public static List<Transporteur> listeAllTransporteursFiltered;
    private OnItemClickListener mListener;
    private Context context;

    public TransporteurAdapter(Context context) {
        this.context = context;
    }

    @Override
    //Rechercher dans la recyclerview
    public Filter getFilter() {
        return new Filter() {
            @Override
            protected FilterResults performFiltering(CharSequence charSequence) {
                String charString = charSequence.toString();
                if (charString.isEmpty()) {
                    listeAllTransporteursFiltered = listeAllTransporteurs;
                } else {
                    List<Transporteur> filteredList = new ArrayList<>();
                    for (Transporteur row : filteredList) {
                        if (row.getNomTransporteur().contains(charString.toLowerCase())) {
                            filteredList.add(row);
                        }
                    }
                    listeAllTransporteursFiltered = filteredList;
                }

                FilterResults filterResults = new FilterResults();
                filterResults.values = listeAllTransporteursFiltered;
                return filterResults;
            }

            @Override
            protected void publishResults(CharSequence charSequence, FilterResults filterResults) {
                listeAllTransporteursFiltered = (ArrayList<Transporteur>) filterResults.values;
                notifyDataSetChanged();
            }
        };
    }

    public void setOnItemClickListener(OnItemClickListener listener) {
        mListener = listener;
    }

    @Override
    public MyViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View itemView = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.ligne_transporteur, parent, false);
        return new MyViewHolder(itemView, mListener);
    }

    @Override
    public void onBindViewHolder(final MyViewHolder holder, final int position) {
        final Transporteur t = CommandesActivity.listeAllTransporteursFiltre.get(position);

        DecimalFormat df = new DecimalFormat("0.00");
        df.setMaximumFractionDigits(2);//arrondi à 2 chiffres après la virgule
        df.setMinimumFractionDigits(2);
        df.setDecimalSeparatorAlwaysShown(true);
        df.setRoundingMode(RoundingMode.HALF_UP);

        if (t.getMax1() != null) {
            holder.max1.setText(" <1kg:"+df.format(t.getMax1())+"€");
        } else {
            holder.max1.setText(" <1kg:N.C.");
        }
        if (t.getMax2() != null) {
            holder.max2.setText(" <2kg:"+df.format(t.getMax2())+"€");
        } else {
            holder.max1.setText(" <2kg:N.C.");
        }
        if (t.getMax3() != null) {
            holder.max3.setText(" <3kg:"+df.format(t.getMax3())+"€");
        } else {
            holder.max3.setText(" <3kg:N.C.");
        }
        if (t.getMax4() != null) {
            holder.max4.setText(" <4kg:"+df.format(t.getMax4())+"€");
        } else {
            holder.max4.setText(" <4kg:N.C.");
        }
        if (t.getMax5() != null) {
            holder.max5.setText(" <5kg:"+df.format(t.getMax5())+"€");
        } else {
            holder.max5.setText(" <5kg:N.C.");
        }
        if (t.getMax6() != null) {
            holder.max6.setText(" <6kg:"+df.format(t.getMax6())+"€");
        } else {
            holder.max6.setText(" <6kg:N.C.");
        }
        if (t.getMax7() != null) {
            holder.max7.setText(" <7kg:"+df.format(t.getMax7())+"€");
        } else {
            holder.max7.setText(" <7kg:N.C.");
        }
        if (t.getMax8() != null) {
            holder.max8.setText(" <8kg:"+df.format(t.getMax8())+"€");
        } else {
            holder.max8.setText(" <8kg:N.C.");
        }
        if (t.getMax9() != null) {
            holder.max9.setText(" <9kg:"+df.format(t.getMax9())+"€");
        } else {
            holder.max9.setText(" <9kg:N.C.");
        }
        if (t.getMax10() != null) {
            holder.max10.setText("<10kg:"+df.format(t.getMax10())+"€");
        } else {
            holder.max10.setText("<10kg:N.C.");
        }
        if (t.getMax15() != null) {
            holder.max15.setText("<15kg:"+df.format(t.getMax15())+"€");
        } else {
            holder.max15.setText("<15kg:N.C.");
        }
        if (t.getMax20() != null) {
            holder.max20.setText("<20kg:"+df.format(t.getMax20())+"€");
        } else {
            holder.max20.setText("<20kg:N.C.");
        }
        if (t.getMax25() != null) {
            holder.max25.setText("<25kg:"+df.format(t.getMax25())+"€");
        } else {
            holder.max25.setText("<25kg:N.C.");
        }
        if (t.getMax30() != null) {
            holder.max30.setText("<30kg:"+df.format(t.getMax30())+"€");
        } else {
            holder.max30.setText("<30kg:N.C.");
        }
        if (t.getSup30() != null) {
            holder.sup30.setText(">30kg:"+df.format(t.getSup30())+"€");
        } else {
            holder.sup30.setText(">30kg:N.C.");
        }
        Double prixTransporteurCommande = 0.00;
        Boolean siSupplement = false;
        Double supplementLivraison = 0.00;
        if (CommandesActivity.currentCommande.getPoidsTotal() > 30000) {
            holder.sup30.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getSup30();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 25000) {
            holder.max30.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax30();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 20000) {
            holder.max25.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax25();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 15000) {
            holder.max20.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax20();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 10000) {
            holder.max15.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax15();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 9000) {
            holder.max10.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax10();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 8000) {
            holder.max9.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax9();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 7000) {
            holder.max8.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax8();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 6000) {
            holder.max7.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax7();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 5000) {
            holder.max6.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax6();
} else if (CommandesActivity.currentCommande.getPoidsTotal() > 4000) {
            holder.max5.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax5();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 3000) {
            holder.max4.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax4();        }
        else if (CommandesActivity.currentCommande.getPoidsTotal() > 2000) {
            holder.max3.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax3();
        } else if (CommandesActivity.currentCommande.getPoidsTotal() > 1000) {
            holder.max2.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax2();
        } else {
            holder.max1.setTextColor(context.getColor(R.color.colorCommande));
            prixTransporteurCommande = t.getMax1();
        }
        //Ajoouter le supplément de livraison ici si il existe pour ce client
        //Uniquement pour le transporteur Chronopost FRANCE si on dispose du code postal du client et client pays FRANCE = 8
        if (t.getId() == 8 && CommandesActivity.listeAllSupplementTransporteurChronopostFrance != null && CommandesActivity.currentCommande.getIdPaysClient() == 8 && CommandesActivity.currentCommande.getCodePostalClient() != null) {
            //Chercher le supplément
            TransporteurChronopostFranceSupplement ts = CommandesActivity.getSupplementTransporteurChronospostFrance(CommandesActivity.currentCommande.getCodePostalClient());
            if (ts != null) {
                CommandesActivity.currentCommande.setIdTransporteurPrixSupplementLivraison(8);
                CommandesActivity.currentCommande.setPrixSupplementLivraison(ts.getSupplementTransporteur());
                prixTransporteurCommande += CommandesActivity.currentCommande.getPrixSupplementLivraison();
                siSupplement = true;
                supplementLivraison = ts.getSupplementTransporteur();
            }
        } else {
            CommandesActivity.currentCommande.setIdTransporteurPrixSupplementLivraison(0);
            CommandesActivity.currentCommande.setPrixSupplementLivraison(0);
        }
        CommandesActivity.appliquerPrixLivraison();

        if (t.getNomTransporteur() != null) {
            if (prixTransporteurCommande == 0) {
                holder.nom_transporteur.setText(t.getNomTransporteur() + " (GRATUIT)");
            } else if (siSupplement && supplementLivraison > 0) {
                holder.nom_transporteur.setText(t.getNomTransporteur() + " (Dès " + df.format(prixTransporteurCommande) + "€)\n(Suplément livraison: "+df.format(supplementLivraison)+"€)");
            } else {
                holder.nom_transporteur.setText(t.getNomTransporteur() + " (Dès " + df.format(prixTransporteurCommande) + "€)");
            }
            if (t.getDetailsTransporteur() != null) {
                holder.details_transporteur.setText(t.getDetailsTransporteur());
            }
        } else {
            holder.nom_transporteur.setText("");
        }
   }

    @Override
    public int getItemCount() {
        if (CommandesActivity.listeAllTransporteursFiltre != null) {
            return CommandesActivity.listeAllTransporteursFiltre.size();
        } else {
            return 0;
        }
    }

    public interface OnItemClickListener {
        void onChoisirClick(int position);
    }

    public class MyViewHolder extends RecyclerView.ViewHolder {
        public TextView nom_transporteur, details_transporteur, max1, max2, max3, max4, max5, max6, max7, max8, max9, max10, max15, max20, max25, max30, sup30;
        private Button choisir;
        public LinearLayout ligneTransporteur, details_prix_transporteur;

        public MyViewHolder(View view, final OnItemClickListener listener) {
            super(view);

            StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
            StrictMode.setThreadPolicy(policy);

            nom_transporteur = view.findViewById(R.id.nom_transporteur);
            details_transporteur = view.findViewById(R.id.details_transporteur);
            details_prix_transporteur = view.findViewById(R.id.details_prix_transporteur);

            max1 = view.findViewById(R.id.max1);
            max2 = view.findViewById(R.id.max2);
            max3 = view.findViewById(R.id.max3);
            max4 = view.findViewById(R.id.max4);
            max5 = view.findViewById(R.id.max5);
            max6 = view.findViewById(R.id.max6);
            max7 = view.findViewById(R.id.max7);
            max8 = view.findViewById(R.id.max8);
            max9 = view.findViewById(R.id.max9);
            max10 = view.findViewById(R.id.max10);
            max15 = view.findViewById(R.id.max15);
            max20 = view.findViewById(R.id.max20);
            max25 = view.findViewById(R.id.max25);
            max30 = view.findViewById(R.id.max30);
            sup30 = view.findViewById(R.id.sup30);
            choisir = view.findViewById(R.id.choisir);
            ligneTransporteur = view.findViewById(R.id.ligneTransporteur);

            choisir.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    if (listener != null) {
                        int position = getAdapterPosition();
                        if (position != RecyclerView.NO_POSITION) {
                            if (!CommandesActivity.listeAllTransporteursFiltre.isEmpty()) {
                                CommandesActivity.currentCommande.setIdTransporteur(CommandesActivity.listeAllTransporteursFiltre.get(position).getId());
                                CommandesActivity.currentCommande.setNomTransporteur(CommandesActivity.listeAllTransporteursFiltre.get(position).getNomTransporteur());
                                CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getPrixTransporteur());
                                CommandesActivity.currentCommande.setPrixLivraisonMax1(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax1());
                                CommandesActivity.currentCommande.setPrixLivraisonMax2(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax2());
                                CommandesActivity.currentCommande.setPrixLivraisonMax3(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax3());
                                CommandesActivity.currentCommande.setPrixLivraisonMax4(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax4());
                                CommandesActivity.currentCommande.setPrixLivraisonMax5(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax5());
                                CommandesActivity.currentCommande.setPrixLivraisonMax6(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax6());
                                CommandesActivity.currentCommande.setPrixLivraisonMax7(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax7());
                                CommandesActivity.currentCommande.setPrixLivraisonMax8(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax8());
                                CommandesActivity.currentCommande.setPrixLivraisonMax9(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax9());
                                CommandesActivity.currentCommande.setPrixLivraisonMax10(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax10());
                                CommandesActivity.currentCommande.setPrixLivraisonMax15(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax15());
                                CommandesActivity.currentCommande.setPrixLivraisonMax20(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax20());
                                CommandesActivity.currentCommande.setPrixLivraisonMax25(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax25());
                                CommandesActivity.currentCommande.setPrixLivraisonMax30(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax30());
                                CommandesActivity.currentCommande.setPrixLivraisonSup30(CommandesActivity.listeAllTransporteursFiltre.get(position).getSup30());
                                CommandesActivity.currentCommande.setPrixSupplementLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getSupplementTransporteur());
                                if (CommandesActivity.currentCommande.getPoidsTotal() > 30000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getSup30());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 25000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax30());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 20000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax25());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 15000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax20());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 10000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax15());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 9000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax10());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 8000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax9());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 7000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax8());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 6000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax7());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 5000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax6());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 4000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax5());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 3000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax4());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 2000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax3());
                                } else if (CommandesActivity.currentCommande.getPoidsTotal() > 1000) {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax2());
                                } else {
                                    CommandesActivity.currentCommande.setPrixLivraison(CommandesActivity.listeAllTransporteursFiltre.get(position).getMax1());
                                }
                                CommandesActivity.modeNom.setText(CommandesActivity.currentCommande.getNomTransporteur()+":");
                                //Uniquement si on dispose du code postal du client et client pays FRANCE
                                if (CommandesActivity.listeAllSupplementTransporteurChronopostFrance != null && CommandesActivity.currentCommande.getIdPaysClient() == 8 && CommandesActivity.currentCommande.getCodePostalClient() != null) {
                                    //Chercher le supplément
                                    TransporteurChronopostFranceSupplement ts = CommandesActivity.getSupplementTransporteurChronospostFrance(CommandesActivity.currentCommande.getCodePostalClient());
                                    if (ts != null && CommandesActivity.currentCommande != null) {
                                        CommandesActivity.currentCommande.setIdTransporteurPrixSupplementLivraison(ts.getId());
                                        CommandesActivity.currentCommande.setPrixSupplementLivraison(ts.getSupplementTransporteur());
                                    }
                                } else {
                                    CommandesActivity.currentCommande.setIdTransporteurPrixSupplementLivraison(0);
                                    CommandesActivity.currentCommande.setPrixSupplementLivraison(0);
                                }
                                CommandesActivity.appliquerPrixLivraison();
                            } else {
                                Toast.makeText(context, "Impossible de choisir", Toast.LENGTH_LONG);
                            }
                            CommandesActivity.affichelistetransporteurs = 0;
                            CommandesActivity.barIntituleChampsTransporteurs.setVisibility(View.GONE);
                            CommandesActivity.recyclerViewTransporteurs.setVisibility(View.GONE);
                            CommandesActivity.barIntituleChampsClients.setVisibility(View.GONE);
                            CommandesActivity.recyclerViewClients.setVisibility(View.GONE);
                            CommandesActivity.searchBarTransporteurCommande.setVisibility(View.GONE);
                            CommandesActivity.searchBarClientCommande.setVisibility(View.GONE);
                            CommandesActivity.barNom.setVisibility(View.VISIBLE);
                            CommandesActivity.barIntituleChamps.setVisibility(View.VISIBLE);
                            CommandesActivity.recyclerView.setVisibility(View.VISIBLE);
                            CommandesActivity.searchBar.setVisibility(View.VISIBLE);
                            CommandesActivity.searchBarProduitCommande.setVisibility(View.VISIBLE);
                            CommandesActivity.infos.setVisibility(View.VISIBLE);
                            CommandesActivity.imprimer.setVisibility(View.VISIBLE);
                            CommandesActivity.choixCommande.setVisibility(View.VISIBLE);
                            CommandesActivity.activerToujoursScanner.setVisibility(View.VISIBLE);
                            CommandesActivity.reloadScanner.setVisibility(View.VISIBLE);
                            CommandesActivity.ajouterRemiseCommande.setVisibility(View.VISIBLE);
                            if (CommandesActivity.currentCommande.getPrixLivraison() > 0) {
                                CommandesActivity.livraisonLigne.setVisibility(View.VISIBLE);
                            } else {
                                CommandesActivity.livraisonLigne.setVisibility(View.GONE);
                            }
                        }
                    }
                }
            });
            nom_transporteur.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    if (listener != null) {
                        int position = getAdapterPosition();
                        if (position != RecyclerView.NO_POSITION) {
                            if (!CommandesActivity.listeAllTransporteursFiltre.isEmpty()) {
                                if (details_prix_transporteur.getVisibility() == View.VISIBLE) {
                                    details_prix_transporteur.setVisibility(View.GONE);
                                } else {
                                    details_prix_transporteur.setVisibility(View.VISIBLE);
                                }
                            } else {
                                Toast.makeText(context, "Impossible d'afficher le détail des prix", Toast.LENGTH_LONG);
                            }
                        }
                    }
                }
            });
        }
    }

    //Appeler dès lors du changement du client depuis le clientAdapter
    /*private class GetSupplementTransporteurAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            httpJsonParser = new HttpJsonParser();
            //Pas de paramètres de recherche
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "getSupplementTransporteur.php", "GET", null);

            try {
                int success = jsonObject.getInt("success");
                JSONArray transporteurs;
                if (success == 1) {
                    transporteurs = jsonObject.getJSONArray("transporteurs");
                    for (int i = 0; i < transporteurs.length(); i++) {
                        JSONObject transporteur = transporteurs.getJSONObject(i);
                        try {
                            //Appliquer le supplement transporteur à la commande
                            CommandesActivity.currentCommande.setIdTransporteurPrixSupplementLivraison(parseInt(transporteur.getString("id")));
                            CommandesActivity.currentCommande.setPrixSupplementLivraison(parseDouble(transporteur.getString("supplement")));
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                } else {
                    Toast.makeText(context, "Impossible de récupérer le supplement du transporteur!!!", Toast.LENGTH_LONG).show();
                }

            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);

            DecimalFormat df = new DecimalFormat("0.00");
            df.setMaximumFractionDigits(2);//arrondi à 2 chiffres après la virgule
            df.setMinimumFractionDigits(2);
            df.setDecimalSeparatorAlwaysShown(true);
            df.setRoundingMode(RoundingMode.HALF_UP);

            //Dans le cas ou l'id transporteur sélectionné n'est pas celui des frais supplémentaire de livraison alors annuler le supplément
            if (CommandesActivity.currentCommande.getIdTransporteur() == CommandesActivity.currentCommande.getIdTransporteurPrixSupplementLivraison()) {
                CommandesActivity.prixLivraison.setText(df.format(CommandesActivity.currentCommande.getPrixLivraison()+CommandesActivity.currentCommande.getPrixSupplementLivraison())+"€");
            } else {
                CommandesActivity.currentCommande.setIdTransporteurPrixSupplementLivraison(0);
                CommandesActivity.currentCommande.setPrixSupplementLivraison(0);
                CommandesActivity.prixLivraison.setText(df.format(0) + "€");
            }

            if (CommandesActivity.currentCommande.getPrixLivraison() > 0) {
                CommandesActivity.livraisonLigne.setVisibility(View.VISIBLE);
            } else {
                CommandesActivity.livraisonLigne.setVisibility(View.GONE);
            }

        }
    }*/

}